Whamcloud - gitweb
LU-7108 test: Remove sanityn tests from ALWAYS_EXCEPT list
[fs/lustre-release.git] / lustre / tests / sanityn.sh
old mode 100644 (file)
new mode 100755 (executable)
index 1e65fda..a0bfb32
@@ -3,8 +3,8 @@
 set -e
 
 ONLY=${ONLY:-"$*"}
-# bug number for skipped test: 3192 LU-1205 15528/3811 9977 15528/11549 18080
-ALWAYS_EXCEPT="                14b  18c     19         28   29          35    $SANITYN_EXCEPT"
+# bug number for skipped test: LU-1205 9977/LU-7105 LU-9452
+ALWAYS_EXCEPT="                18c     28           29      $SANITYN_EXCEPT"
 # UPDATE THE COMMENT ABOVE WITH BUG NUMBERS WHEN CHANGING ALWAYS_EXCEPT!
 
 SRCDIR=$(dirname $0)
@@ -38,7 +38,7 @@ if [ $(facet_fstype $SINGLEMDS) = "zfs" ]; then
 # LU-2829 / LU-2887 - make allowances for ZFS slowness
        TEST33_NFILES=${TEST33_NFILES:-1000}
 fi
-
+#                                  23   (min)"
 [ "$SLOW" = "no" ] && EXCEPT_SLOW="33a"
 
 FAIL_ON_ERROR=false
@@ -48,9 +48,6 @@ TRACE=${TRACE:-""}
 
 check_and_setup_lustre
 
-LOVNAME=$($LCTL get_param -n llite.*.lov.common_name | tail -n 1)
-OSTCOUNT=$($LCTL get_param -n lov.$LOVNAME.numobd)
-
 assert_DIR
 rm -rf $DIR1/[df][0-9]* $DIR1/lnk $DIR/[df].${TESTSUITE}*
 
@@ -64,9 +61,6 @@ check_runas_id $RUNAS_ID $RUNAS_GID $RUNAS
 
 build_test_filter
 
-mkdir -p $MOUNT2
-mount_client $MOUNT2
-
 test_1a() {
        touch $DIR1/f1
        [ -f $DIR2/f1 ] || error
@@ -297,7 +291,7 @@ test_13() { # bug 2451 - directory coherency
 }
 run_test 13 "test directory page revocation ===================="
 
-test_14() {
+test_14aa() {
        test_mkdir -p $DIR1/$tdir
        cp -p /bin/ls $DIR1/$tdir/$tfile
        multiop_bg_pause $DIR1/$tdir/$tfile Ow_c || return 1
@@ -307,9 +301,9 @@ test_14() {
        kill -USR1 $MULTIPID
        wait $MULTIPID || return 2
 }
-run_test 14 "execution of file open for write returns -ETXTBSY ="
+run_test 14aa "execution of file open for write returns -ETXTBSY"
 
-test_14a() {
+test_14ab() {
        test_mkdir -p $DIR1/d14
        cp -p `which multiop` $DIR1/d14/multiop || error "cp failed"
         MULTIOP_PROG=$DIR1/d14/multiop multiop_bg_pause $TMP/test14.junk O_c || return 1
@@ -319,7 +313,7 @@ test_14a() {
         wait $MULTIOP_PID || return 3
         rm $TMP/test14.junk $DIR1/d14/multiop || error "removing multiop"
 }
-run_test 14a "open(RDWR) of executing file returns -ETXTBSY ===="
+run_test 14ab "open(RDWR) of executing file returns -ETXTBSY"
 
 test_14b() { # bug 3192, 7040
        test_mkdir -p $DIR1/d14
@@ -751,42 +745,42 @@ enable_lockless_truncate() {
 test_32a() { # bug 11270
        local p="$TMP/$TESTSUITE-$TESTNAME.parameters"
        save_lustre_params client "osc.*.lockless_truncate" > $p
-        cancel_lru_locks osc
-        enable_lockless_truncate 1
-        rm -f $DIR1/$tfile
-        lfs setstripe -c -1 $DIR1/$tfile
-        dd if=/dev/zero of=$DIR1/$tfile count=$OSTCOUNT bs=$STRIPE_BYTES > \
-                /dev/null 2>&1
-        clear_osc_stats
-
-        log "checking cached lockless truncate"
-        $TRUNCATE $DIR1/$tfile 8000000
-        $CHECKSTAT -s 8000000 $DIR2/$tfile || error "wrong file size"
-       [ $(calc_osc_stats lockless_truncate) -ne 0 ] ||
+       cancel_lru_locks osc
+       enable_lockless_truncate 1
+       rm -f $DIR1/$tfile
+       lfs setstripe -c -1 $DIR1/$tfile
+       dd if=/dev/zero of=$DIR1/$tfile count=$OSTCOUNT bs=$STRIPE_BYTES > \
+               /dev/null 2>&1
+       clear_stats osc.*.osc_stats
+
+       log "checking cached lockless truncate"
+       $TRUNCATE $DIR1/$tfile 8000000
+       $CHECKSTAT -s 8000000 $DIR2/$tfile || error "wrong file size"
+       [ $(calc_stats osc.*.osc_stats lockless_truncate) -ne 0 ] ||
                error "cached truncate isn't lockless"
 
-        log "checking not cached lockless truncate"
-        $TRUNCATE $DIR2/$tfile 5000000
-        $CHECKSTAT -s 5000000 $DIR1/$tfile || error "wrong file size"
-       [ $(calc_osc_stats lockless_truncate) -ne 0 ] ||
+       log "checking not cached lockless truncate"
+       $TRUNCATE $DIR2/$tfile 5000000
+       $CHECKSTAT -s 5000000 $DIR1/$tfile || error "wrong file size"
+       [ $(calc_stats osc.*.osc_stats lockless_truncate) -ne 0 ] ||
                error "not cached truncate isn't lockless"
 
-        log "disabled lockless truncate"
-        enable_lockless_truncate 0
-        clear_osc_stats
-        $TRUNCATE $DIR2/$tfile 3000000
-        $CHECKSTAT -s 3000000 $DIR1/$tfile || error "wrong file size"
-        [ $(calc_osc_stats lockless_truncate) -eq 0 ] ||
-                error "lockless truncate disabling failed"
-        rm $DIR1/$tfile
-        # restore lockless_truncate default values
-        restore_lustre_params < $p
-        rm -f $p
+       log "disabled lockless truncate"
+       enable_lockless_truncate 0
+       clear_stats osc.*.osc_stats
+       $TRUNCATE $DIR2/$tfile 3000000
+       $CHECKSTAT -s 3000000 $DIR1/$tfile || error "wrong file size"
+       [ $(calc_stats osc.*.osc_stats lockless_truncate) -eq 0 ] ||
+               error "lockless truncate disabling failed"
+       rm $DIR1/$tfile
+       # restore lockless_truncate default values
+       restore_lustre_params < $p
+       rm -f $p
 }
 run_test 32a "lockless truncate"
 
 test_32b() { # bug 11270
-        remote_ost_nodsh && skip "remote OST with nodsh" && return
+       remote_ost_nodsh && skip "remote OST with nodsh" && return
 
        local node
        local facets=$(get_facets OST)
@@ -799,35 +793,42 @@ test_32b() { # bug 11270
                "ldlm.namespaces.filter-*.contended_locks" >> $p
        save_lustre_params $facets \
                "ldlm.namespaces.filter-*.contention_seconds" >> $p
-       clear_osc_stats
+       clear_stats osc.*.osc_stats
 
-        # agressive lockless i/o settings
-        for node in $(osts_nodes); do
-                do_node $node 'lctl set_param -n ldlm.namespaces.filter-*.max_nolock_bytes 2000000; lctl set_param -n ldlm.namespaces.filter-*.contended_locks 0; lctl set_param -n ldlm.namespaces.filter-*.contention_seconds 60'
-        done
-        lctl set_param -n osc.*.contention_seconds 60
-        for i in $(seq 5); do
-                dd if=/dev/zero of=$DIR1/$tfile bs=4k count=1 conv=notrunc > /dev/null 2>&1
-                dd if=/dev/zero of=$DIR2/$tfile bs=4k count=1 conv=notrunc > /dev/null 2>&1
-        done
-        [ $(calc_osc_stats lockless_write_bytes) -ne 0 ] || error "lockless i/o was not triggered"
-        # disable lockless i/o (it is disabled by default)
-        for node in $(osts_nodes); do
-                do_node $node 'lctl set_param -n ldlm.namespaces.filter-*.max_nolock_bytes 0; lctl set_param -n ldlm.namespaces.filter-*.contended_locks 32; lctl set_param -n ldlm.namespaces.filter-*.contention_seconds 0'
-        done
-        # set contention_seconds to 0 at client too, otherwise Lustre still
-        # remembers lock contention
-        lctl set_param -n osc.*.contention_seconds 0
-        clear_osc_stats
-        for i in $(seq 1); do
-                dd if=/dev/zero of=$DIR1/$tfile bs=4k count=1 conv=notrunc > /dev/null 2>&1
-                dd if=/dev/zero of=$DIR2/$tfile bs=4k count=1 conv=notrunc > /dev/null 2>&1
-        done
-        [ $(calc_osc_stats lockless_write_bytes) -eq 0 ] ||
-                error "lockless i/o works when disabled"
-        rm -f $DIR1/$tfile
-        restore_lustre_params <$p
-        rm -f $p
+       # agressive lockless i/o settings
+       do_nodes $(comma_list $(osts_nodes)) \
+               "lctl set_param -n ldlm.namespaces.*.max_nolock_bytes=2000000 \
+                       ldlm.namespaces.filter-*.contended_locks=0 \
+                       ldlm.namespaces.filter-*.contention_seconds=60"
+       lctl set_param -n osc.*.contention_seconds=60
+       for i in {1..5}; do
+               dd if=/dev/zero of=$DIR1/$tfile bs=4k count=1 conv=notrunc > \
+                       /dev/null 2>&1
+               dd if=/dev/zero of=$DIR2/$tfile bs=4k count=1 conv=notrunc > \
+                       /dev/null 2>&1
+       done
+       [ $(calc_stats osc.*.osc_stats lockless_write_bytes) -ne 0 ] ||
+               error "lockless i/o was not triggered"
+       # disable lockless i/o (it is disabled by default)
+       do_nodes $(comma_list $(osts_nodes)) \
+               "lctl set_param -n ldlm.namespaces.filter-*.max_nolock_bytes=0 \
+                       ldlm.namespaces.filter-*.contended_locks=32 \
+                       ldlm.namespaces.filter-*.contention_seconds=0"
+       # set contention_seconds to 0 at client too, otherwise Lustre still
+       # remembers lock contention
+       lctl set_param -n osc.*.contention_seconds=0
+       clear_stats osc.*.osc_stats
+       for i in {1..1}; do
+               dd if=/dev/zero of=$DIR1/$tfile bs=4k count=1 conv=notrunc > \
+                       /dev/null 2>&1
+               dd if=/dev/zero of=$DIR2/$tfile bs=4k count=1 conv=notrunc > \
+                       /dev/null 2>&1
+       done
+       [ $(calc_stats osc.*.osc_stats lockless_write_bytes) -eq 0 ] ||
+               error "lockless i/o works when disabled"
+       rm -f $DIR1/$tfile
+       restore_lustre_params <$p
+       rm -f $p
 }
 run_test 32b "lockless i/o"
 
@@ -879,7 +880,7 @@ test_33a() {
 
             [ $fstype = ldiskfs ] && jbdold=$(print_jbd_stat)
             echo "=== START createmany old: $jbdold transaction"
-            local elapsed=$(do_and_time "do_nodes $CLIENT1,$CLIENT2 createmany -o $DIR1/$tdir-\\\$(hostname)-$i/f- -r $DIR2/$tdir-\\\$(hostname)-$i/f- $nfiles > /dev/null 2>&1")
+            local elapsed=$(do_and_time "do_nodes $CLIENT1,$CLIENT2 createmany -o $DIR1/$tdir-\\\$(hostname)-$i/f- -r$DIR2/$tdir-\\\$(hostname)-$i/f- $nfiles > /dev/null 2>&1")
             [ $fstype = ldiskfs ] && jbdnew=$(print_jbd_stat)
             [ $fstype = ldiskfs ] && jbd=$(( jbdnew - jbdold ))
             echo "=== END   createmany new: $jbdnew transaction :  $jbd transactions  nfiles $nfiles time $elapsed COS=$COS"
@@ -928,14 +929,14 @@ test_33b() {
                avgjbd=0
                avgtime=0
                for i in 1 2 3; do
-                       do_node $CLIENT1 "$LFS mkdir -i $MDTIDX -p \
+                       do_node $CLIENT1 "$LFS mkdir -i $MDTIDX \
                                          $DIR1/$tdir-\\\$(hostname)-$i"
 
                        jbdold=$(print_jbd_stat)
                        echo "=== START createmany old: $jbdold transaction"
                        local elapsed=$(do_and_time "do_nodes $CLIENT1,$CLIENT2\
                                createmany -o $DIR1/$tdir-\\\$(hostname)-$i/f- \
-                               -r $DIR2/$tdir-\\\$(hostname)-$i/f- $nfiles > \
+                               -r$DIR2/$tdir-\\\$(hostname)-$i/f- $nfiles > \
                                                                /dev/null 2>&1")
                        jbdnew=$(print_jbd_stat)
                        jbd=$(( jbdnew - jbdold ))
@@ -961,6 +962,118 @@ test_33b() {
 }
 run_test 33b "COS: cross create/delete, 2 clients, benchmark under remote dir"
 
+test_33c() {
+       [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs" && return
+       [ $(lustre_version_code $SINGLEMDS) -lt $(version_code 2.7.63) ] &&
+               skip "DNE CoS not supported" && return
+
+       sync
+
+       mkdir $DIR/$tdir
+       # remote mkdir is done on MDT2, which enqueued lock of $tdir on MDT1
+       $LFS mkdir -i 1 $DIR/$tdir/d1
+       do_facet mds1 "lctl set_param -n mdt.*.sync_count=0"
+       mkdir $DIR/$tdir/d2
+       local sync_count=$(do_facet mds1 \
+               "lctl get_param -n mdt.*MDT0000.sync_count")
+       [ $sync_count -eq 1 ] || error "Sync-Lock-Cancel not triggered"
+
+       $LFS mkdir -i 1 $DIR/$tdir/d3
+       do_facet mds1 "lctl set_param -n mdt.*.sync_count=0"
+       # during sleep remote mkdir should have been committed and canceled
+       # remote lock spontaneously, which shouldn't trigger sync
+       sleep 6
+       mkdir $DIR/$tdir/d4
+       local sync_count=$(do_facet mds1 \
+               "lctl get_param -n mdt.*MDT0000.sync_count")
+       [ $sync_count -eq 0 ] || error "Sync-Lock-Cancel triggered"
+}
+run_test 33c "Cancel cross-MDT lock should trigger Sync-Lock-Cancel"
+
+ops_do_cos() {
+       local nodes=$(comma_list $(mdts_nodes))
+       do_nodes $nodes "lctl set_param -n mdt.*.async_commit_count=0"
+       sh -c "$@"
+       local async_commit_count=$(do_nodes $nodes \
+               "lctl get_param -n mdt.*.async_commit_count" | calc_sum)
+       [ $async_commit_count -gt 0 ] || error "CoS not triggerred"
+
+       rm -rf $DIR/$tdir
+       sync
+}
+
+test_33d() {
+       [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs" && return
+       [ $(lustre_version_code $SINGLEMDS) -lt $(version_code 2.7.63) ] &&
+               skip "DNE CoS not supported" && return
+
+       sync
+       # remote directory create
+       mkdir $DIR/$tdir
+       ops_do_cos "$LFS mkdir -i 1 $DIR/$tdir/subdir"
+       # remote directory unlink
+       $LFS mkdir -i 1 $DIR/$tdir
+       ops_do_cos "rmdir $DIR/$tdir"
+       # striped directory create
+       mkdir $DIR/$tdir
+       ops_do_cos "$LFS mkdir -c 2 $DIR/$tdir/subdir"
+       # striped directory setattr
+       $LFS mkdir -c 2 $DIR/$tdir
+       touch $DIR/$tdir
+       ops_do_cos "chmod 713 $DIR/$tdir"
+       # striped directory unlink
+       $LFS mkdir -c 2 $DIR/$tdir
+       touch $DIR/$tdir
+       ops_do_cos "rmdir $DIR/$tdir"
+       # cross-MDT link
+       $LFS mkdir -c 2 $DIR/$tdir
+       $LFS mkdir -i 0 $DIR/$tdir/d1
+       $LFS mkdir -i 1 $DIR/$tdir/d2
+       touch $DIR/$tdir/d1/tgt
+       ops_do_cos "ln $DIR/$tdir/d1/tgt $DIR/$tdir/d2/src"
+       # cross-MDT rename
+       $LFS mkdir -c 2 $DIR/$tdir
+       $LFS mkdir -i 0 $DIR/$tdir/d1
+       $LFS mkdir -i 1 $DIR/$tdir/d2
+       touch $DIR/$tdir/d1/src
+       ops_do_cos "mv $DIR/$tdir/d1/src $DIR/$tdir/d2/tgt"
+       # migrate
+       $LFS mkdir -i 0 $DIR/$tdir
+       ops_do_cos "$LFS migrate -m 1 $DIR/$tdir"
+       return 0
+}
+run_test 33d "DNE distributed operation should trigger COS"
+
+test_33e() {
+       [ -n "$CLIENTS" ] || { skip "Need two or more clients" && return 0; }
+       [ $CLIENTCOUNT -ge 2 ] ||
+               { skip "Need two or more clients, have $CLIENTCOUNT" &&
+                                                               return 0; }
+       [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs" && return
+       [ $(lustre_version_code $SINGLEMDS) -lt $(version_code 2.7.63) ] &&
+               skip "DNE CoS not supported" && return
+
+       local client2=${CLIENT2:-$(hostname)}
+
+       sync
+
+       local nodes=$(comma_list $(mdts_nodes))
+       do_nodes $nodes "lctl set_param -n mdt.*.async_commit_count=0"
+
+       $LFS mkdir -c 2 $DIR/$tdir
+       mkdir $DIR/$tdir/subdir
+       echo abc > $DIR/$tdir/$tfile
+       do_node $client2 echo dfg >> $DIR/$tdir/$tfile
+       do_node $client2 touch $DIR/$tdir/subdir
+
+       local async_commit_count=$(do_nodes $nodes \
+               "lctl get_param -n mdt.*.async_commit_count" | calc_sum)
+       [ $async_commit_count -gt 0 ] && error "CoS triggerred"
+
+       return 0
+}
+run_test 33e "DNE local operation shouldn't trigger COS"
+
 # End commit on sharing tests
 
 get_ost_lock_timeouts() {
@@ -983,6 +1096,7 @@ cleanup_34() {
 }
 
 test_34() { #16129
+       remote_ost_nodsh && skip "remote OST with nodsh" && return
         local OPER
         local lock_in
         local lock_out
@@ -1241,6 +1355,32 @@ test_39c() {
 }
 run_test 39c "check truncate mtime update ======================"
 
+test_39d() { # LU-7310
+       touch $DIR1/$tfile
+       touch -m -d @$TEST_39_MTIME $DIR1/$tfile
+
+       local mtime1=$(stat -c %Y $DIR2/$tfile)
+       [ "$mtime1" = $TEST_39_MTIME ] ||
+               error "mtime: $mtime1, should be $TEST_39_MTIME"
+
+       # force sync write
+       # define OBD_FAIL_OSC_NO_GRANT 0x411
+       $LCTL set_param fail_loc=0x411
+
+       local d1=$(date +%s)
+       echo hello >> $DIR1/$tfile
+       local d2=$(date +%s)
+
+       $LCTL set_param fail_loc=0
+
+       cancel_lru_locks osc
+
+       local mtime2=$(stat -c %Y $DIR2/$tfile)
+       [ "$mtime2" -ge "$d1" ] && [ "$mtime2" -le "$d2" ] ||
+               error "mtime is not updated on write: $d1 <= $mtime2 <= $d2"
+}
+run_test 39d "sync write should update mtime"
+
 # check that pid exists hence second operation wasn't blocked by first one
 # if it is so then there is no conflict, return 0
 # else second operation is conflicting with first one, return 1
@@ -1260,6 +1400,7 @@ check_pdo_conflict() {
 # pdirop tests
 # test 40: check non-blocking operations
 test_40a() {
+       remote_mds_nodsh && skip "remote MDS with nodsh" && return
 #define OBD_FAIL_ONCE|OBD_FAIL_MDS_PDO_LOCK    0x145
        do_facet $SINGLEMDS lctl set_param fail_loc=0x80000145
        touch $DIR2
@@ -1280,15 +1421,16 @@ test_40a() {
        rmdir $DIR2/$tfile-3
        check_pdo_conflict $PID1 || error "unlink is blocked"
 
-       # all operations above shouldn't wait the first one
+       #  all operations above shouldn't wait the first one
        check_pdo_conflict $PID1 || error "parallel operation is blocked"
        wait $PID1
-       rm -r $DIR1/*
+       rm -rf $DIR/$tfile*
        return 0
 }
 run_test 40a "pdirops: create vs others =============="
 
 test_40b() {
+       remote_mds_nodsh && skip "remote MDS with nodsh" && return
 #define OBD_FAIL_ONCE|OBD_FAIL_MDS_PDO_LOCK    0x145
        do_facet $SINGLEMDS lctl set_param fail_loc=0x80000145
        touch $DIR1/$tfile &
@@ -1312,12 +1454,13 @@ test_40b() {
 
         check_pdo_conflict $PID1 || error "parallel operation is blocked"
        wait $PID1
-       rm -r $DIR1/*
+       rm -rf $DIR/$tfile*
        return 0
 }
 run_test 40b "pdirops: open|create and others =============="
 
 test_40c() {
+       remote_mds_nodsh && skip "remote MDS with nodsh" && return
        touch $DIR1/$tfile
 #define OBD_FAIL_ONCE|OBD_FAIL_MDS_PDO_LOCK    0x145
        do_facet $SINGLEMDS lctl set_param fail_loc=0x80000145
@@ -1342,12 +1485,13 @@ test_40c() {
         # all operations above shouldn't wait the first one
        check_pdo_conflict $PID1 || error "parallel operation is blocked"
        wait $PID1
-       rm -r $DIR1/*
+       rm -rf $DIR/$tfile*
        return 0
 }
 run_test 40c "pdirops: link and others =============="
 
 test_40d() {
+       remote_mds_nodsh && skip "remote MDS with nodsh" && return
        touch $DIR1/$tfile
 #define OBD_FAIL_ONCE|OBD_FAIL_MDS_PDO_LOCK    0x145
        do_facet $SINGLEMDS lctl set_param fail_loc=0x80000145
@@ -1377,6 +1521,7 @@ test_40d() {
 run_test 40d "pdirops: unlink and others =============="
 
 test_40e() {
+       remote_mds_nodsh && skip "remote MDS with nodsh" && return
        touch $DIR1/$tfile
 #define OBD_FAIL_ONCE|OBD_FAIL_MDS_PDO_LOCK    0x145
        do_facet $SINGLEMDS lctl set_param fail_loc=0x80000145
@@ -1399,7 +1544,7 @@ test_40e() {
        # all operations above shouldn't wait the first one
        check_pdo_conflict $PID1 || error "parallel operation is blocked"
        wait $PID1
-       rm -r $DIR1/*
+       rm -rf $DIR/$tfile*
        return 0
 }
 run_test 40e "pdirops: rename and others =============="
@@ -1413,7 +1558,7 @@ test_41a() {
        sleep 1
        mkdir $DIR2/$tfile && error "mkdir must fail"
        check_pdo_conflict $PID1 && { wait $PID1; echo "mkdir isn't blocked"; }
-       rm -r $DIR1/*
+       rm -rf $DIR/$tfile*
        return 0
 }
 run_test 41a "pdirops: create vs mkdir =============="
@@ -1426,7 +1571,7 @@ test_41b() {
        sleep 1
        $MULTIOP $DIR2/$tfile oO_CREAT:O_EXCL:c && error "create must fail"
        check_pdo_conflict $PID1 && { wait $PID1; error "create isn't blocked"; }
-       rm -r $DIR1/*
+       rm -rf $DIR/$tfile*
        return 0
 }
 run_test 41b "pdirops: create vs create =============="
@@ -1440,7 +1585,7 @@ test_41c() {
        sleep 1
        link $DIR2/$tfile-2 $DIR2/$tfile && error "link must fail"
        check_pdo_conflict $PID1 && { wait $PID1; error "link isn't blocked"; }
-       rm -r $DIR1/*
+       rm -rf $DIR/$tfile*
        return 0
 }
 run_test 41c "pdirops: create vs link =============="
@@ -1453,7 +1598,7 @@ test_41d() {
        sleep 1
        rm $DIR2/$tfile || error "unlink must succeed"
        check_pdo_conflict $PID1 && { wait $PID1; error "unlink isn't blocked"; }
-       rm -r $DIR1/*
+       rm -rf $DIR/$tfile*
        return 0
 }
 run_test 41d "pdirops: create vs unlink =============="
@@ -1467,7 +1612,7 @@ test_41e() {
        sleep 1
        mv $DIR2/$tfile-2 $DIR2/$tfile || error "rename must succeed"
        check_pdo_conflict $PID1 && { wait $PID1; error "rename isn't blocked"; }
-       rm -r $DIR1/*
+       rm -rf $DIR/$tfile*
        return 0
 }
 run_test 41e "pdirops: create and rename (tgt) =============="
@@ -1480,7 +1625,7 @@ test_41f() {
        sleep 1
        mv $DIR2/$tfile $DIR2/$tfile-2 || error "rename must succeed"
        check_pdo_conflict $PID1 && { wait $PID1; error "rename isn't blocked"; }
-       rm -r $DIR1/*
+       rm -rf $DIR/$tfile*
        return 0
 }
 run_test 41f "pdirops: create and rename (src) =============="
@@ -1493,7 +1638,7 @@ test_41g() {
        sleep 1
        stat $DIR2/$tfile > /dev/null || error "stat must succeed"
        check_pdo_conflict $PID1 && { wait $PID1; error "getattr isn't blocked"; }
-       rm -r $DIR1/*
+       rm -rf $DIR/$tfile*
        return 0
 }
 run_test 41g "pdirops: create vs getattr =============="
@@ -1506,7 +1651,7 @@ test_41h() {
        sleep 1
        ls -lia $DIR2/ > /dev/null
        check_pdo_conflict $PID1 && { wait $PID1; error "readdir isn't blocked"; }
-       rm -r $DIR1/*
+       rm -rf $DIR/$tfile*
        return 0
 }
 run_test 41h "pdirops: create vs readdir =============="
@@ -1520,7 +1665,7 @@ test_42a() {
        sleep 1
        mkdir $DIR2/$tfile && error "mkdir must fail"
        check_pdo_conflict $PID1 && { wait $PID1; error "mkdir isn't blocked"; }
-       rm -r $DIR1/*
+       rm -rf $DIR/$tfile*
        return 0
 }
 run_test 42a "pdirops: mkdir vs mkdir =============="
@@ -1533,7 +1678,7 @@ test_42b() {
        sleep 1
        $MULTIOP $DIR2/$tfile oO_CREAT:O_EXCL:c && error "create must fail"
        check_pdo_conflict $PID1 && { wait $PID1; error "create isn't blocked"; }
-       rm -r $DIR1/*
+       rm -rf $DIR/$tfile*
        return 0
 }
 run_test 42b "pdirops: mkdir vs create =============="
@@ -1547,7 +1692,7 @@ test_42c() {
        sleep 1
        link $DIR2/$tfile-2 $DIR2/$tfile && error "link must fail"
        check_pdo_conflict $PID1 && { wait $PID1; error "link isn't blocked"; }
-       rm -r $DIR1/*
+       rm -rf $DIR/$tfile*
        return 0
 }
 run_test 42c "pdirops: mkdir vs link =============="
@@ -1560,7 +1705,7 @@ test_42d() {
        sleep 1
        rmdir $DIR2/$tfile || error "unlink must succeed"
        check_pdo_conflict $PID1 && { wait $PID1; error "unlink isn't blocked"; }
-       rm -r $DIR1/*
+       rm -rf $DIR/$tfile*
        return 0
 }
 run_test 42d "pdirops: mkdir vs unlink =============="
@@ -1574,7 +1719,7 @@ test_42e() {
        sleep 1
        mv -T $DIR2/$tfile-2 $DIR2/$tfile && error "rename must fail"
        check_pdo_conflict $PID1 && { wait $PID1; error "rename isn't blocked"; }
-       rm -r $DIR1/*
+       rm -rf $DIR/$tfile*
        return 0
 }
 run_test 42e "pdirops: mkdir and rename (tgt) =============="
@@ -1587,7 +1732,7 @@ test_42f() {
        sleep 1
        mv $DIR2/$tfile $DIR2/$tfile-2 || error "rename must succeed"
        check_pdo_conflict $PID1 && { wait $PID1; error "rename isn't blocked"; }
-       rm -r $DIR1/*
+       rm -rf $DIR/$tfile*
        return 0
 }
 run_test 42f "pdirops: mkdir and rename (src) =============="
@@ -1600,7 +1745,7 @@ test_42g() {
        sleep 1
        stat $DIR2/$tfile > /dev/null || error "stat must succeed"
        check_pdo_conflict $PID1 && { wait $PID1; error "getattr isn't blocked"; }
-       rm -r $DIR1/*
+       rm -rf $DIR/$tfile*
        return 0
 }
 run_test 42g "pdirops: mkdir vs getattr =============="
@@ -1613,7 +1758,7 @@ test_42h() {
        sleep 1
        ls -lia $DIR2/ > /dev/null
        check_pdo_conflict $PID1 && { wait $PID1; error "readdir isn't blocked"; }
-       rm -r $DIR1/*
+       rm -rf $DIR/$tfile*
        return 0
 }
 run_test 42h "pdirops: mkdir vs readdir =============="
@@ -1628,7 +1773,7 @@ test_43a() {
        sleep 1
        mkdir $DIR2/$tfile || error "mkdir must succeed"
        check_pdo_conflict $PID1 && { wait $PID1; error "mkdir isn't blocked"; }
-       rm -r $DIR1/*
+       rm -rf $DIR/$tfile*
        return 0
 }
 run_test 43a "pdirops: unlink vs mkdir =============="
@@ -1642,7 +1787,7 @@ test_43b() {
        sleep 1
        $MULTIOP $DIR2/$tfile oO_CREAT:O_EXCL:c || error "create must succeed"
        check_pdo_conflict $PID1 && { wait $PID1; error "create isn't blocked"; }
-       rm -r $DIR1/*
+       rm -rf $DIR/$tfile*
        return 0
 }
 run_test 43b "pdirops: unlink vs create =============="
@@ -1657,7 +1802,7 @@ test_43c() {
        sleep 1
        link $DIR2/$tfile-2 $DIR2/$tfile || error "link must succeed"
        check_pdo_conflict $PID1 && { wait $PID1; error "link isn't blocked"; }
-       rm -r $DIR1/*
+       rm -rf $DIR/$tfile*
        return 0
 }
 run_test 43c "pdirops: unlink vs link =============="
@@ -1671,7 +1816,7 @@ test_43d() {
        sleep 1
        rm $DIR2/$tfile && error "unlink must fail"
        check_pdo_conflict $PID1 && { wait $PID1; error "unlink isn't blocked"; }
-       rm -r $DIR1/*
+       rm -rf $DIR/$tfile*
        return 0
 }
 run_test 43d "pdirops: unlink vs unlink =============="
@@ -1686,7 +1831,7 @@ test_43e() {
        sleep 1
        mv -u $DIR2/$tfile-2 $DIR2/$tfile || error "rename must succeed"
        check_pdo_conflict $PID1 && { wait $PID1; error "rename isn't blocked"; }
-       rm -r $DIR1/*
+       rm -rf $DIR/$tfile*
        return 0
 }
 run_test 43e "pdirops: unlink and rename (tgt) =============="
@@ -1700,7 +1845,7 @@ test_43f() {
        sleep 1
        mv $DIR2/$tfile $DIR2/$tfile-2 && error "rename must fail"
        check_pdo_conflict $PID1 && { wait $PID1; error "rename isn't blocked"; }
-       rm -r $DIR1/*
+       rm -rf $DIR/$tfile*
        return 0
 }
 run_test 43f "pdirops: unlink and rename (src) =============="
@@ -1714,7 +1859,7 @@ test_43g() {
        sleep 1
        stat $DIR2/$tfile > /dev/null && error "stat must fail"
        check_pdo_conflict $PID1 && { wait $PID1; error "getattr isn't blocked"; }
-       rm -r $DIR1/*
+       rm -rf $DIR/$tfile*
        return 0
 }
 run_test 43g "pdirops: unlink vs getattr =============="
@@ -1728,7 +1873,7 @@ test_43h() {
        sleep 1
        ls -lia $DIR2/ > /dev/null
        check_pdo_conflict $PID1 && { wait $PID1; error "readdir isn't blocked"; }
-       rm -r $DIR1/*
+       rm -rf $DIR/$tfile*
        return 0
 }
 run_test 43h "pdirops: unlink vs readdir =============="
@@ -1744,7 +1889,7 @@ test_43i() {
        $LFS mkdir -i 1 $DIR2/$tfile || error "remote mkdir must succeed"
        check_pdo_conflict $PID1 &&
                { wait $PID1; error "remote mkdir isn't blocked"; }
-       rm -r $DIR1/*
+       rm -rf $DIR/$tfile*
        return 0
 }
 run_test 43i "pdirops: unlink vs remote mkdir"
@@ -1759,7 +1904,7 @@ test_44a() {
        sleep 1
        mkdir $DIR2/$tfile && error "mkdir must fail"
        check_pdo_conflict $PID1 && { wait $PID1; error "mkdir isn't blocked"; }
-       rm -r $DIR1/*
+       rm -rf $DIR/$tfile*
        return 0
 }
 run_test 44a "pdirops: rename tgt vs mkdir =============="
@@ -1773,7 +1918,7 @@ test_44b() {
        sleep 1
        $MULTIOP $DIR2/$tfile oO_CREAT:O_EXCL:c && error "create must fail"
        check_pdo_conflict $PID1 && { wait $PID1; error "create isn't blocked"; }
-       rm -r $DIR1/*
+       rm -rf $DIR/$tfile*
        return 0
 }
 run_test 44b "pdirops: rename tgt vs create =============="
@@ -1788,7 +1933,7 @@ test_44c() {
        sleep 1
        link $DIR2/$tfile-3 $DIR2/$tfile && error "link must fail"
        check_pdo_conflict $PID1 && { wait $PID1; error "link isn't blocked"; }
-       rm -r $DIR1/*
+       rm -rf $DIR/$tfile*
        return 0
 }
 run_test 44c "pdirops: rename tgt vs link =============="
@@ -1802,7 +1947,7 @@ test_44d() {
        sleep 1
        rm $DIR2/$tfile || error "unlink must succeed"
        check_pdo_conflict $PID1 && { wait $PID1; error "unlink isn't blocked"; }
-       rm -r $DIR1/*
+       rm -rf $DIR/$tfile*
        return 0
 }
 run_test 44d "pdirops: rename tgt vs unlink =============="
@@ -1818,7 +1963,7 @@ test_44e() {
        sleep 1
        mv $DIR2/$tfile-3 $DIR2/$tfile || error "rename must succeed"
        check_pdo_conflict $PID1 && { wait $PID1; error "rename isn't blocked"; }
-       rm -r $DIR1/*
+       rm -rf $DIR/$tfile*
        return 0
 }
 run_test 44e "pdirops: rename tgt and rename (tgt) =============="
@@ -1833,7 +1978,7 @@ test_44f() {
        sleep 1
        mv $DIR2/$tfile $DIR2/$tfile-3 || error "rename must succeed"
        check_pdo_conflict $PID1 && { wait $PID1; error "rename isn't blocked"; }
-       rm -r $DIR1/*
+       rm -rf $DIR/$tfile*
        return 0
 }
 run_test 44f "pdirops: rename tgt and rename (src) =============="
@@ -1847,7 +1992,7 @@ test_44g() {
        sleep 1
        stat $DIR2/$tfile > /dev/null || error "stat must succeed"
        check_pdo_conflict $PID1 && { wait $PID1; error "getattr isn't blocked"; }
-       rm -r $DIR1/*
+       rm -rf $DIR/$tfile*
        return 0
 }
 run_test 44g "pdirops: rename tgt vs getattr =============="
@@ -1861,7 +2006,7 @@ test_44h() {
        sleep 1
        ls -lia $DIR2/ > /dev/null
        check_pdo_conflict $PID1 && { wait $PID1; error "readdir isn't blocked"; }
-       rm -r $DIR1/*
+       rm -rf $DIR/$tfile*
        return 0
 }
 run_test 44h "pdirops: rename tgt vs readdir =============="
@@ -1878,7 +2023,7 @@ test_44i() {
        $LFS mkdir -i 1 $DIR2/$tfile && error "remote mkdir must fail"
        check_pdo_conflict $PID1 && { wait $PID1;
                                error "remote mkdir isn't blocked"; }
-       rm -r $DIR1/*
+       rm -rf $DIR/$tfile*
        return 0
 }
 run_test 44i "pdirops: rename tgt vs remote mkdir"
@@ -1893,7 +2038,7 @@ test_45a() {
        sleep 1
        mkdir $DIR2/$tfile || error "mkdir must succeed"
        check_pdo_conflict $PID1 && { wait $PID1; error "mkdir isn't blocked"; }
-       rm -r $DIR1/*
+       rm -rf $DIR/$tfile*
        return 0
 }
 run_test 45a "pdirops: rename src vs mkdir =============="
@@ -1907,7 +2052,7 @@ test_45b() {
        sleep 1
        $MULTIOP $DIR2/$tfile oO_CREAT:O_EXCL:c || error "create must succeed"
        check_pdo_conflict $PID1 && { wait $PID1; error "create isn't blocked"; }
-       rm -r $DIR1/*
+       rm -rf $DIR/$tfile*
        return 0
 }
 run_test 45b "pdirops: rename src vs create =============="
@@ -1922,7 +2067,7 @@ test_45c() {
        sleep 1
        link $DIR2/$tfile-3 $DIR2/$tfile || error "link must succeed"
        check_pdo_conflict $PID1 && { wait $PID1; error "link isn't blocked"; }
-       rm -r $DIR1/*
+       rm -rf $DIR/$tfile*
        return 0
 }
 run_test 45c "pdirops: rename src vs link =============="
@@ -1936,7 +2081,7 @@ test_45d() {
        sleep 1
        rm $DIR2/$tfile && error "unlink must fail"
        check_pdo_conflict $PID1 && { wait $PID1; error "unlink isn't blocked"; }
-       rm -r $DIR1/*
+       rm -rf $DIR/$tfile*
        return 0
 }
 run_test 45d "pdirops: rename src vs unlink =============="
@@ -1951,7 +2096,7 @@ test_45e() {
        sleep 1
        mv $DIR2/$tfile-3 $DIR2/$tfile || error "rename must succeed"
        check_pdo_conflict $PID1 && { wait $PID1; error "rename isn't blocked"; }
-       rm -r $DIR1/*
+       rm -rf $DIR/$tfile*
        return 0
 }
 run_test 45e "pdirops: rename src and rename (tgt) =============="
@@ -1965,7 +2110,7 @@ test_45f() {
        sleep 1
        mv $DIR2/$tfile $DIR2/$tfile-3 && error "rename must fail"
        check_pdo_conflict $PID1 && { wait $PID1; error "rename isn't blocked"; }
-       rm -r $DIR1/*
+       rm -rf $DIR/$tfile*
        return 0
 }
 run_test 45f "pdirops: rename src and rename (src) =============="
@@ -1979,7 +2124,7 @@ test_45g() {
        sleep 1
        stat $DIR2/$tfile > /dev/null && error "stat must fail"
        check_pdo_conflict $PID1 && { wait $PID1; error "getattr isn't blocked"; }
-       rm -r $DIR1/*
+       rm -rf $DIR/$tfile*
        return 0
 }
 run_test 45g "pdirops: rename src vs getattr =============="
@@ -1993,7 +2138,7 @@ test_45h() {
        sleep 1
        ls -lia $DIR2/ > /dev/null
        check_pdo_conflict $PID1 && { wait $PID1; error "readdir isn't blocked"; }
-       rm -r $DIR1/*
+       rm -rf $DIR/$tfile*
        return 0
 }
 run_test 45h "pdirops: unlink vs readdir =============="
@@ -2009,7 +2154,7 @@ test_45i() {
        $LFS mkdir -i 1 $DIR2/$tfile || error "create remote dir must succeed"
        check_pdo_conflict $PID1 && { wait $PID1;
                                error "create remote dir isn't blocked"; }
-       rm -r $DIR1/*
+       rm -rf $DIR/$tfile*
        return 0
 }
 run_test 45i "pdirops: rename src vs remote mkdir"
@@ -2024,7 +2169,7 @@ test_46a() {
        sleep 1
        mkdir $DIR2/$tfile && error "mkdir must fail"
        check_pdo_conflict $PID1 && { wait $PID1; error "mkdir isn't blocked"; }
-       rm -r $DIR1/*
+       rm -rf $DIR/$tfile*
        return 0
 }
 run_test 46a "pdirops: link vs mkdir =============="
@@ -2038,7 +2183,7 @@ test_46b() {
        sleep 1
        $MULTIOP $DIR2/$tfile oO_CREAT:O_EXCL:c && error "create must fail"
        check_pdo_conflict $PID1 && { wait $PID1; error "create isn't blocked"; }
-       rm -r $DIR1/*
+       rm -rf $DIR/$tfile*
        return 0
 }
 run_test 46b "pdirops: link vs create =============="
@@ -2052,7 +2197,7 @@ test_46c() {
        sleep 1
        link $DIR2/$tfile $DIR2/$tfile && error "link must fail"
        check_pdo_conflict $PID1 && { wait $PID1; error "link isn't blocked"; }
-       rm -r $DIR1/*
+       rm -rf $DIR/$tfile*
        return 0
 }
 run_test 46c "pdirops: link vs link =============="
@@ -2066,7 +2211,7 @@ test_46d() {
        sleep 1
        rm $DIR2/$tfile || error "unlink must succeed"
        check_pdo_conflict $PID1 && { wait $PID1; error "unlink isn't blocked"; }
-       rm -r $DIR1/*
+       rm -rf $DIR/$tfile*
        return 0
 }
 run_test 46d "pdirops: link vs unlink =============="
@@ -2081,7 +2226,7 @@ test_46e() {
        sleep 1
        mv $DIR2/$tfile-3 $DIR2/$tfile || error "rename must succeed"
        check_pdo_conflict $PID1 && { wait $PID1; error "rename isn't blocked"; }
-       rm -r $DIR1/*
+       rm -rf $DIR/$tfile*
        return 0
 }
 run_test 46e "pdirops: link and rename (tgt) =============="
@@ -2096,7 +2241,7 @@ test_46f() {
        sleep 1
        mv $DIR2/$tfile $DIR2/$tfile-3 || error "rename must succeed"
        check_pdo_conflict $PID1 && { wait $PID1; error "rename isn't blocked"; }
-       rm -r $DIR1/*
+       rm -rf $DIR/$tfile*
        return 0
 }
 run_test 46f "pdirops: link and rename (src) =============="
@@ -2110,7 +2255,7 @@ test_46g() {
        sleep 1
        stat $DIR2/$tfile > /dev/null || error "stat must succeed"
        check_pdo_conflict $PID1 && { wait $PID1; error "getattr isn't blocked"; }
-       rm -r $DIR1/*
+       rm -rf $DIR/$tfile*
        return 0
 }
 run_test 46g "pdirops: link vs getattr =============="
@@ -2125,7 +2270,7 @@ test_46h() {
        ls -lia $DIR2/ > /dev/null
        check_pdo_conflict $PID1 && { wait $PID1;
                        error "readdir isn't blocked"; }
-       rm -r $DIR1/*
+       rm -rf $DIR/$tfile*
        return 0
 }
 run_test 46h "pdirops: link vs readdir =============="
@@ -2141,7 +2286,7 @@ test_46i() {
        $LFS mkdir -i 1 $DIR2/$tfile && error "remote mkdir must fail"
        check_pdo_conflict $PID1 && { wait $PID1;
                                error "remote mkdir isn't blocked"; }
-       rm -r $DIR1/*
+       rm -rf $DIR/$tfile*
        return 0
 }
 run_test 46i "pdirops: link vs remote mkdir"
@@ -2156,7 +2301,7 @@ test_47a() {
        sleep 1
        mkdir $DIR2/$tfile && error "mkdir must fail"
        check_pdo_conflict $PID1 && { wait $PID1; error "mkdir isn't blocked"; }
-       rm -r $DIR1/*
+       rm -rf $DIR/$tfile*
        return 0
 }
 run_test 47a "pdirops: remote mkdir vs mkdir"
@@ -2171,7 +2316,7 @@ test_47b() {
        multiop $DIR2/$tfile oO_CREAT:O_EXCL:c && error "create must fail"
        check_pdo_conflict $PID1 && { wait $PID1;
                                        error "create isn't blocked"; }
-       rm -r $DIR1/*
+       rm -rf $DIR/$tfile*
        return 0
 }
 run_test 47b "pdirops: remote mkdir vs create"
@@ -2186,7 +2331,7 @@ test_47c() {
        sleep 1
        link $DIR2/$tfile-2 $DIR2/$tfile && error "link must fail"
        check_pdo_conflict $PID1 && { wait $PID1; error "link isn't blocked"; }
-       rm -r $DIR1/*
+       rm -rf $DIR/$tfile*
        return 0
 }
 run_test 47c "pdirops: remote mkdir vs link"
@@ -2201,7 +2346,7 @@ test_47d() {
        rmdir $DIR2/$tfile || error "unlink must succeed"
        check_pdo_conflict $PID1 && { wait $PID1;
                                        error "unlink isn't blocked"; }
-       rm -r $DIR1/*
+       rm -rf $DIR/$tfile*
        return 0
 }
 run_test 47d "pdirops: remote mkdir vs unlink"
@@ -2217,7 +2362,7 @@ test_47e() {
        mv -T $DIR2/$tfile-2 $DIR2/$tfile && error "rename must fail"
        check_pdo_conflict $PID1 && { wait $PID1;
                                        error "rename isn't blocked"; }
-       rm -r $DIR1/*
+       rm -rf $DIR/$tfile*
        return 0
 }
 run_test 47e "pdirops: remote mkdir and rename (tgt)"
@@ -2232,7 +2377,7 @@ test_47f() {
        mv $DIR2/$tfile $DIR2/$tfile-2 || error "rename must succeed"
        check_pdo_conflict $PID1 && { wait $PID1;
                                        error "rename isn't blocked"; }
-       rm -r $DIR1/*
+       rm -rf $DIR/$tfile*
        return 0
 }
 run_test 47f "pdirops: remote mkdir and rename (src)"
@@ -2247,7 +2392,7 @@ test_47g() {
        stat $DIR2/$tfile > /dev/null || error "stat must succeed"
        check_pdo_conflict $PID1 && { wait $PID1;
                                        error "getattr isn't blocked"; }
-       rm -r $DIR1/*
+       rm -rf $DIR/$tfile*
        return 0
 }
 run_test 47g "pdirops: remote mkdir vs getattr"
@@ -2269,13 +2414,13 @@ test_51a() {
        local filesize
        local origfile=/etc/hosts
 
-       filesize=`stat -c %s $origfile`
+       filesize=$(stat -c %s $origfile)
 
        # create an empty file
-       $MCREATE $DIR1/$tfile
+       $MCREATE $DIR1/$tfile || error "can't create $DIR1/$tfile"
        # cache layout lock on both mount point
-       stat $DIR1/$tfile > /dev/null
-       stat $DIR2/$tfile > /dev/null
+       stat $DIR1/$tfile > /dev/null || error "stat $DIR1/$tfile failed"
+       stat $DIR2/$tfile > /dev/null || error "stat $DIR2/$tfile failed"
 
        # open and sleep 2 seconds then read
        $MULTIOP $DIR2/$tfile o_2r${filesize}c &
@@ -2283,12 +2428,13 @@ test_51a() {
        sleep 1
 
        # create the layout of testing file
-       dd if=$origfile of=$DIR1/$tfile conv=notrunc > /dev/null
+       dd if=$origfile of=$DIR1/$tfile conv=notrunc > /dev/null ||
+               error "dd $DIR1/$tfile failed"
 
        # MULTIOP proc should be able to read enough bytes and exit
        sleep 2
-       kill -0 $pid && error "multiop is still there"
-       cmp $origfile $DIR2/$tfile || error "$MCREATE and $DIR2/$tfile differs"
+       kill -0 $pid 2> /dev/null && error "multiop is still there"
+       cmp $origfile $DIR2/$tfile || error "$origfile and $DIR2/$tfile differs"
 
        rm -f $DIR1/$tfile
 }
@@ -2301,7 +2447,7 @@ test_51b() {
        local tmpfile=`mktemp`
 
        # create an empty file
-       $MCREATE $DIR1/$tfile
+       $MCREATE $DIR1/$tfile || error "mcreate $DIR1/$tfile failed"
 
        # delay glimpse so that layout has changed when glimpse finish
 #define OBD_FAIL_GLIMPSE_DELAY 0x1404
@@ -2311,10 +2457,11 @@ test_51b() {
        sleep 1
 
        # create layout of testing file
-       dd if=/dev/zero of=$DIR1/$tfile bs=1k count=1 conv=notrunc > /dev/null
+       dd if=/dev/zero of=$DIR1/$tfile bs=1k count=1 conv=notrunc >/dev/null ||
+               error "dd $DIR1/$tfile failed"
 
        wait $pid
-       local fsize=`cat $tmpfile`
+       local fsize=$(cat $tmpfile)
 
        [ x$fsize = x1024 ] || error "file size is $fsize, should be 1024"
 
@@ -2326,11 +2473,12 @@ test_51c() {
        [ $OSTCOUNT -ge 2 ] || { skip "need at least 2 osts"; return; }
 
        # set default layout to have 1 stripe
-       mkdir -p $DIR1/$tdir
+       mkdir $DIR1/$tdir
        $LFS setstripe -c 1 $DIR1/$tdir
 
        # create a file with empty layout
-       $MCREATE $DIR1/$tdir/$tfile
+       $MCREATE $DIR1/$tdir/$tfile ||
+               error "$MCREATE $DIR1/$tdir/$tfile failed"
 
 #define OBD_FAIL_MDS_LL_BLOCK 0x172
        do_facet $SINGLEMDS $LCTL set_param fail_loc=0x172
@@ -2343,8 +2491,14 @@ test_51c() {
 
        # write something to the file, it should be blocked on fetching layout
        dd if=/dev/zero of=$DIR2/$tdir/$tfile bs=1k count=1 conv=notrunc
-       local cnt=$($LFS getstripe -c $DIR2/$tdir/$tfile)
-       [ $cnt -eq $OSTCOUNT ] || error "have $cnt stripes, expected $OSTCOUNT"
+       local stripecnt=$($LFS getstripe -c $DIR2/$tdir/$tfile)
+       wait $pid
+
+       # lod_qos.c::min_stripe_count() allows setstripe with a default stripe
+       # count to succeed with only 3/4 of the number of stripes (rounded up),
+       # so creating striped files does not fail if an OST is offline or full
+       [ $stripecnt -ge $((OSTCOUNT - $OSTCOUNT / 4)) ] ||
+               error "layout wrong: getstripe -c $stripecnt < $OSTCOUNT * 3/4"
 
        rm -fr $DIR1/$tdir
 }
@@ -2381,7 +2535,7 @@ test_54_part1()
        echo "==> rename vs getattr vs setxattr should not deadlock"
        mkdir -p $DIR/d1/d2/d3 || error "(1) mkdir failed"
 
-       do_facet mds $LCTL set_param fail_loc=$1
+       do_facet mds1 $LCTL set_param fail_loc=$1
 
        mv -T $DIR/d1/d2/d3 $DIR/d1/d3 &
        PID1=$!
@@ -2403,7 +2557,7 @@ test_54_part2() {
        echo "==> rename vs getattr vs open vs getattr should not deadlock"
        mkdir -p $DIR/d1/d2/d3 || error "(1) mkdir failed"
 
-       do_facet mds $LCTL set_param fail_loc=$1
+       do_facet mds1 $LCTL set_param fail_loc=$1
 
        mv -T $DIR/d1/d2/d3 $DIR/d1/d3 &
        PID1=$!
@@ -2448,7 +2602,7 @@ test_55a() {
        mkdir -p $DIR/d1/d2 $DIR/d3 || error "(1) mkdir failed"
 
 #define OBD_FAIL_MDS_RENAME4              0x156
-       do_facet mds $LCTL set_param fail_loc=0x80000156
+       do_facet mds1 $LCTL set_param fail_loc=0x80000156
 
        mv -T $DIR/d1/d2 $DIR/d3/d2 &
        PID1=$!
@@ -2466,7 +2620,7 @@ test_55b()
        mkdir -p $DIR/d1/d2 $DIR/d3 || error "(1) mkdir failed"
 
 #define OBD_FAIL_MDS_RENAME4             0x156
-       do_facet mds $LCTL set_param fail_loc=0x80000156
+       do_facet mds1 $LCTL set_param fail_loc=0x80000156
 
        mv -T $DIR/d1/d2 $DIR/d3/d2 &
        PID1=$!
@@ -2484,7 +2638,7 @@ test_55c()
        mkdir -p $DIR/d1/d2 $DIR/d3 || error "(1) mkdir failed"
 
 #define OBD_FAIL_MDS_RENAME4              0x156
-       do_facet mds $LCTL set_param fail_loc=0x156
+       do_facet mds1 $LCTL set_param fail_loc=0x156
 
        mv -T $DIR/d1/d2 $DIR/d3/d2 &
        PID1=$!
@@ -2512,7 +2666,7 @@ test_55d()
        touch $DIR/f1
 
 #define OBD_FAIL_MDS_RENAME3              0x155
-       do_facet mds $LCTL set_param fail_loc=0x155
+       do_facet mds1 $LCTL set_param fail_loc=0x155
        mv $DIR/f1 $DIR/$tdir &
        PID1=$!
        sleep 2
@@ -2616,7 +2770,7 @@ test_70b() { # LU-2781
 }
 run_test 70b "remove files after calling rm_entry"
 
-test_71() {
+test_71a() {
        local server_version=$(lustre_version_code $SINGLEMDS)
 
        [[ $server_version -lt $(version_code 2.1.6) ]] &&
@@ -2625,7 +2779,8 @@ test_71() {
        # Patch not applied to 2.2 and 2.3 branches
        [[ $server_version -ge $(version_code 2.2.0) ]] &&
        [[ $server_version -lt $(version_code 2.4.0) ]] &&
-               skip "Need MDS version at least 2.4.0" && return
+               skip "Need MDS version earlier than 2.2.0 or at least 2.4.0" &&
+                       return
 
        checkfiemap --test ||
                { skip "checkfiemap not runnable: $?" && return; }
@@ -2657,7 +2812,34 @@ test_71() {
        echo $can2
        [ $can3 -eq $can4 ] || error $((can2-can1)) "cancel RPC occured."
 }
-run_test 71 "correct file map just after write operation is finished"
+run_test 71a "correct file map just after write operation is finished"
+
+test_71b() {
+       local server_version=$(lustre_version_code $SINGLEMDS)
+
+       [[ $server_version -lt $(version_code 2.1.6) ]] &&
+               skip "Need MDS version at least 2.1.6" && return
+
+       # Patch not applied to 2.2 and 2.3 branches
+       [[ $server_version -ge $(version_code 2.2.0) ]] &&
+       [[ $server_version -lt $(version_code 2.4.0) ]] &&
+               skip "Need MDS version earlier than 2.2.0 or at least 2.4.0" &&
+                       return
+       [[ $OSTCOUNT -ge 2 ]] || { skip "need at least 2 osts"; return; }
+
+       checkfiemap --test ||
+               { skip "error $?: checkfiemap failed" && return; }
+
+       mkdir -p $DIR1/$tdir
+
+       $LFS setstripe -c -1 $DIR1/$tdir || error "setstripe failed"
+       dd if=/dev/urandom of=$DIR1/$tdir/$tfile bs=40K count=1
+       [ "$(facet_fstype ost$(($($GETSTRIPE -i $DIR1/$tdir/$tfile) + 1)))" = \
+               "zfs" ] &&
+               skip "ORI-366/LU-1941: FIEMAP unimplemented on ZFS" && return 0
+       checkfiemap $DIR1/$tdir/$tfile 40960 || error "checkfiemap failed"
+}
+run_test 71b "check fiemap support for stripecount > 1"
 
 test_72() {
        local p="$TMP/sanityN-$TESTNAME.parameters"
@@ -2702,14 +2884,16 @@ test_73() {
                error "setfattr1 failed"
        getfattr -n user.attr1 $DIR2/$tfile || error "getfattr1 failed"
        getfattr -n user.attr1 $DIR1/$tfile || error "getfattr2 failed"
-       clear_llite_stats
+       clear_stats llite.*.stats
        # PR lock should be cached by now on both clients
        getfattr -n user.attr1 $DIR1/$tfile || error "getfattr3 failed"
        # 2 hits for getfattr(0)+getfattr(size)
-       [ $(calc_llite_stats getxattr_hits) -eq 2 ] || error "not cached in $DIR1"
+       [ $(calc_stats llite.*.stats getxattr_hits) -eq 2 ] ||
+               error "not cached in $DIR1"
        getfattr -n user.attr1 $DIR2/$tfile || error "getfattr4 failed"
        # 4 hits for more getfattr(0)+getfattr(size)
-       [ $(calc_llite_stats getxattr_hits) -eq 4 ] || error "not cached in $DIR2"
+       [ $(calc_stats llite.*.stats getxattr_hits) -eq 4 ] ||
+               error "not cached in $DIR2"
        rm -f $DIR2/$tfile
 
        restore_lustre_params < $p
@@ -2754,7 +2938,7 @@ test_76() { #LU-946
                skip "Need MDS version at least 2.5.53" && return
 
        remote_mds_nodsh && skip "remote MDS with nodsh" && return
-       local fcount=2048
+       local fcount=$((MDSCOUNT * 256))
        declare -a fd_list
        declare -a fid_list
 
@@ -2770,20 +2954,28 @@ test_76() { #LU-946
        # drop all open locks and close any cached "open" files on the client
        cancel_lru_locks mdc
 
-       echo -n "open files "
-       ulimit -n 8096
+       local open_fids_cmd="$LCTL get_param -n mdt.*.exports.'$nid'.open_files"
+       local fid_list=($(do_nodes $(comma_list $(mdts_nodes)) $open_fids_cmd))
+       local already=${#fid_list[@]}
+       for (( i = 0; i < $already; i++ )) ; do
+               log "already open[$i]: $($LFS fid2path $DIR2 ${fid_list[i]})"
+       done
+
+       echo -n "opening files: "
+       ulimit -n $((fcount + 50))
        for ((i = 0; i < $fcount; i++)); do
                touch $DIR/$tdir/f_$i
-               local fd=$(free_fd)
-               local cmd="exec $fd<$DIR/$tdir/f_$i"
-               eval $cmd
+               local fd=$(free_fd ${fd_list[i]})
+               local open_cmd="exec $fd<$DIR/$tdir/f_$i"
+               eval $open_cmd
+
                fd_list[i]=$fd
-               echo -n "."
+
+               (( $i % 32 == 0 )) && echo -n "."
        done
        echo
 
-       local get_open_fids="$LCTL get_param -n mdt.*.exports.'$nid'.open_files"
-       local fid_list=($(do_nodes $(comma_list $(mdts_nodes)) $get_open_fids))
+       fid_list=($(do_nodes $(comma_list $(mdts_nodes)) $open_fids_cmd))
 
        # Possible errors in openfiles FID list.
        # 1. Missing FIDs. Check 1
@@ -2793,19 +2985,28 @@ test_76() { #LU-946
        # 5. Valid FID, points to some other file. Check 3
 
        # Check 1
-       [ ${#fid_list[@]} -ne $fcount ] &&
-               error "${#fid_list[@]} != $fcount open files"
-
-       for (( i = 0; i < $fcount; i++ )) ; do
-               cmd="exec ${fd_list[i]}</dev/null"
-               eval $cmd
-               filename=$($LFS fid2path $DIR2 ${fid_list[i]})
+       [ ${#fid_list[@]} -ne $((fcount + already)) ] &&
+               error "${#fid_list[@]} != $fcount (+$already old) open files"
+
+       echo -n "closing files: "
+       for (( fd = 0, fid = 0; fd < $fcount; fd++, fid++ )) ; do
+               local close_cmd="exec ${fd_list[fd]}<&-"
+               eval $close_cmd
+               filename=$($LFS fid2path $DIR2 ${fid_list[fid]})
+
+               while [[ ! "$filename" =~ "$DIR2/$tdir/f_" ]]; do
+                       echo "skip old open file $filename"
+                       ((fid++))
+                       filename=$($LFS fid2path $DIR2 ${fid_list[fid]})
+               done
 
                # Check 2
                rm --interactive=no $filename
                [ $? -ne 0 ] &&
-                       error "Nonexisting fid ${fid_list[i]} listed."
+                       error "Nonexisting fid ${fid_list[fid]} listed."
+               (( $fd % 32 == 0 )) && echo -n "."
        done
+       echo
 
        # Check 3
        ls_op=$(ls $DIR2/$tdir | wc -l)
@@ -2814,7 +3015,7 @@ test_76() { #LU-946
 
        rm -rf $DIR/$tdir
 }
-run_test 76 "Verify open file for 2048 files"
+run_test 76 "Verify MDT open_files listing"
 
 nrs_write_read() {
        local n=16
@@ -2825,21 +3026,23 @@ nrs_write_read() {
        $LFS setstripe -c $OSTCOUNT $dir || error "setstripe to $dir failed"
        chmod 777 $dir
 
-       do_nodes $CLIENTS $myRUNAS dd if=/dev/zero of="$dir/nrs_r_$HOSTNAME"\
-               bs=1M count=$n > /dev/null 2>&1
+       do_nodes $CLIENTS $myRUNAS \
+               dd if=/dev/zero of="$dir/nrs_r_$HOSTNAME" bs=1M count=$n ||
+               error "dd at 0 on client failed (1)"
 
        for ((i = 0; i < $n; i++)); do
-               do_nodes $CLIENTS $myRUNAS dd if=/dev/zero\
-                       of="$dir/nrs_w_$HOSTNAME" bs=1M seek=$i count=1\
-                        > /dev/null 2>&1 &
+               do_nodes $CLIENTS $myRUNAS dd if=/dev/zero \
+                       of="$dir/nrs_w_$HOSTNAME" bs=1M seek=$i count=1 ||
+                        error "dd at ${i}MB on client failed (2)" &
                local pids_w[$i]=$!
        done
        do_nodes $CLIENTS sync;
        cancel_lru_locks osc
 
        for ((i = 0; i < $n; i++)); do
-               do_nodes $CLIENTS $myRUNAS dd if="$dir/nrs_w_$HOSTNAME"\
-                       of=/dev/zero bs=1M seek=$i count=1 > /dev/null 2>&1 &
+               do_nodes $CLIENTS $myRUNAS dd if="$dir/nrs_w_$HOSTNAME" \
+                       of=/dev/zero bs=1M seek=$i count=1 > /dev/null ||
+                       error "dd at ${i}MB on client failed (3)" &
                local pids_r[$i]=$!
        done
        cancel_lru_locks osc
@@ -2852,26 +3055,30 @@ nrs_write_read() {
 }
 
 test_77a() { #LU-3266
-       do_facet $SINGLEMDS lctl set_param ost.OSS.*.nrs_policies="fifo"
+       oss=$(comma_list $(osts_nodes))
+       do_nodes $oss lctl set_param ost.OSS.*.nrs_policies="fifo"
        nrs_write_read
 
        return 0
 }
 run_test 77a "check FIFO NRS policy"
 
-
 test_77b() { #LU-3266
-       do_facet $SINGLEMDS lctl set_param ost.OSS.*.nrs_policies="crrn"
-       do_facet $SINGLEMDS lctl set_param ost.OSS.*.nrs_crrn_quantum=1
+       oss=$(comma_list $(osts_nodes))
+
+       do_nodes $oss lctl set_param ost.OSS.*.nrs_policies="crrn" \
+                          ost.OSS.*.nrs_crrn_quantum=1
 
        echo "policy: crr-n, crrn_quantum 1"
        nrs_write_read
 
-       do_facet $SINGLEMDS lctl set_param ost.OSS.*.nrs_crrn_quantum=64
+       do_nodes $oss lctl set_param ost.OSS.*.nrs_crrn_quantum=64
 
        echo "policy: crr-n, crrn_quantum 64"
        nrs_write_read
 
+       # cleanup
+       do_nodes $oss lctl set_param ost.OSS.ost_io.nrs_policies="fifo"
        return 0
 }
 run_test 77b "check CRR-N NRS policy"
@@ -2879,44 +3086,29 @@ run_test 77b "check CRR-N NRS policy"
 orr_trr() {
        local policy=$1
 
-       for i in $(seq 1 $OSTCOUNT)
-       do
-               do_facet ost"$i" lctl set_param \
-                       ost.OSS.ost_io.nrs_policies=$policy
-               do_facet ost"$i" lctl set_param \
-                       ost.OSS.*.nrs_"$policy"_quantum=1
-               do_facet ost"$i" lctl set_param \
-                       ost.OSS.*.nrs_"$policy"_offset_type="physical"
-               do_facet ost"$i" lctl set_param \
-                       ost.OSS.*.nrs_"$policy"_supported="reads"
-       done
+       oss=$(comma_list $(osts_nodes))
 
-       echo "policy: $policy, ${policy}_quantum 1, ${policy}_offset_type \
-                               physical, ${policy}_supported reads"
+       do_nodes $oss lctl set_param ost.OSS.ost_io.nrs_policies=$policy \
+                                    ost.OSS.*.nrs_"$policy"_quantum=1 \
+                                    ost.OSS.*.nrs_"$policy"_offset_type="physical" \
+                                    ost.OSS.*.nrs_"$policy"_supported="reads"
+
+       echo "policy: $policy, ${policy}_quantum 1, ${policy}_offset_type physical, ${policy}_supported reads"
        nrs_write_read
 
-       for i in $(seq 1 $OSTCOUNT)
-       do
-               do_facet ost"$i" lctl set_param \
-                       ost.OSS.*.nrs_${policy}_supported="writes"
-               do_facet ost"$i" lctl set_param \
-                       ost.OSS.*.nrs_${policy}_quantum=64
-       done
-       echo "policy: $policy, ${policy}_quantum 64, \
-               ${policy}_offset_type physical, ${policy}_supported writes"
+       do_nodes $oss lctl set_param ost.OSS.*.nrs_${policy}_supported="writes" \
+                                    ost.OSS.*.nrs_${policy}_quantum=64
+
+       echo "policy: $policy, ${policy}_quantum 64, ${policy}_offset_type physical, ${policy}_supported writes"
        nrs_write_read
 
-       for i in $(seq 1 $OSTCOUNT)
-       do
-               do_facet ost"$i" lctl set_param \
-                       ost.OSS.*.nrs_${policy}_supported="reads_and_writes"
-               do_facet ost"$i" lctl set_param \
-                       ost.OSS.*.nrs_${policy}_offset_type="logical"
-       done
-       echo "policy: $policy, ${policy}_quantum 64, \
-               ${policy}_offset_type logical, ${policy}_supported reads_and_writes"
+       do_nodes $oss lctl set_param ost.OSS.*.nrs_${policy}_supported="reads_and_writes" \
+                                    ost.OSS.*.nrs_${policy}_offset_type="logical"
+       echo "policy: $policy, ${policy}_quantum 64, ${policy}_offset_type logical, ${policy}_supported reads_and_writes"
        nrs_write_read
 
+       # cleanup
+       do_nodes $oss lctl set_param ost.OSS.ost_io.nrs_policies="fifo"
        return 0
 }
 
@@ -2938,55 +3130,98 @@ tbf_rule_operate()
        shift 1
 
        do_facet $facet lctl set_param \
-               ost.OSS.ost_io.nrs_tbf_rule="$@"
+               ost.OSS.ost_io.nrs_tbf_rule="$*"
        [ $? -ne 0 ] &&
-               error "failed to operate on TBF rules"
+               error "failed to run operate '$*' on TBF rules"
+}
+
+tbf_verify() {
+       local dir=$DIR/$tdir
+       local client1=${CLIENT1:-$(hostname)}
+       local myRUNAS="$3"
+
+       mkdir $dir || error "mkdir $dir failed"
+       $LFS setstripe -c 1 $dir || error "setstripe to $dir failed"
+       chmod 777 $dir
+
+       echo "Limited write rate: $1, read rate: $2"
+       echo "Verify the write rate is under TBF control"
+       local rate=$(do_node $client1 $myRUNAS dd if=/dev/zero of=$dir/tbf \
+               bs=1M count=100 oflag=direct 2>&1 | awk '/bytes/ {print $8}')
+       echo "Write speed is $rate"
+
+       # verify the write rate does not exceed 110% of TBF limited rate
+       [ $(bc <<< "$rate < 1.1 * $1") -eq 1 ] ||
+               error_ignore LU-9140 "The write rate ($rate) exceeds 110% of preset rate ($1)"
+
+       cancel_lru_locks osc
+
+       echo "Verify the read rate is under TBF control"
+       rate=$(do_node $client1 $myRUNAS dd if=$dir/tbf of=/dev/null \
+               bs=1M count=100 iflag=direct 2>&1 | awk '/bytes/ {print $8}')
+       echo "Read speed is $rate"
+
+       # verify the read rate does not exceed 110% of TBF limited rate
+       [ $(bc <<< "$rate < 1.1 * $2") -eq 1 ] ||
+               error_ignore LU-9140 "The read rate ($rate) exceeds 110% of preset rate ($2)"
+
+       cancel_lru_locks osc
+       rm -rf $dir || error "rm -rf $dir failed"
 }
 
 test_77e() {
-       for i in $(seq 1 $OSTCOUNT)
-       do
-               do_facet ost"$i" lctl set_param \
-                       ost.OSS.ost_io.nrs_policies="tbf\ nid"
-               [ $? -ne 0 ] &&
-                       error "failed to set TBF policy"
-       done
+       local server_version=$(lustre_version_code ost1)
+       [[ $server_version -ge $(version_code 2.7.58) ]] ||
+               { skip "Need server version newer than 2.7.57"; return 0; }
 
-       # Only operate rules on ost0 since OSTs might run on the same OSS
+       oss=$(comma_list $(osts_nodes))
+
+       do_nodes $oss lctl set_param ost.OSS.ost_io.nrs_policies="tbf\ nid"
+       [ $? -ne 0 ] && error "failed to set TBF policy"
+
+       local idis
+       local rateis
+       if [ $(lustre_version_code ost1) -ge $(version_code 2.8.54) ]; then
+               idis="nid="
+               rateis="rate="
+       fi
+
+       # Only operate rules on ost1 since OSTs might run on the same OSS
        # Add some rules
-       tbf_rule_operate ost0 "start\ localhost\ {0@lo}\ 1000"
+       tbf_rule_operate ost1 "start\ localhost\ ${idis}{0@lo}\ ${rateis}1000"
        local address=$(comma_list "$(host_nids_address $CLIENTS $NETTYPE)")
        local client_nids=$(nids_list $address "\\")
-       tbf_rule_operate ost0 "start\ clients\ {$client_nids}\ 100"
-       tbf_rule_operate ost0 "start\ others\ {*.*.*.*@$NETTYPE}\ 50"
+       tbf_rule_operate ost1 "start\ clients\ ${idis}{$client_nids}\ ${rateis}100"
+       tbf_rule_operate ost1 "start\ others\ ${idis}{*.*.*.*@$NETTYPE}\ ${rateis}50"
        nrs_write_read
 
        # Change the rules
-       tbf_rule_operate ost0 "change\ localhost\ 1001"
-       tbf_rule_operate ost0 "change\ clients\ 101"
-       tbf_rule_operate ost0 "change\ others\ 51"
+       tbf_rule_operate ost1 "change\ localhost\ ${rateis}1001"
+       tbf_rule_operate ost1 "change\ clients\ ${rateis}101"
+       tbf_rule_operate ost1 "change\ others\ ${rateis}51"
        nrs_write_read
 
        # Stop the rules
-       tbf_rule_operate ost0 "stop\ localhost"
-       tbf_rule_operate ost0 "stop\ clients"
-       tbf_rule_operate ost0 "stop\ others"
+       tbf_rule_operate ost1 "stop\ localhost"
+       tbf_rule_operate ost1 "stop\ clients"
+       tbf_rule_operate ost1 "stop\ others"
        nrs_write_read
 
        # Cleanup the TBF policy
-       for i in $(seq 1 $OSTCOUNT)
-       do
-               do_facet ost"$i" lctl set_param \
-                       ost.OSS.ost_io.nrs_policies="fifo"
-               [ $? -ne 0 ] &&
-                       error "failed to set policy back to fifo"
-       done
+       do_nodes $oss lctl set_param ost.OSS.ost_io.nrs_policies="fifo"
+       [ $? -ne 0 ] && error "failed to set policy back to fifo"
        nrs_write_read
        return 0
 }
 run_test 77e "check TBF NID nrs policy"
 
 test_77f() {
+       local server_version=$(lustre_version_code ost1)
+       [[ $server_version -ge $(version_code 2.7.58) ]] ||
+               { skip "Need server version newer than 2.7.57"; return 0; }
+
+       oss=$(comma_list $(osts_nodes))
+
        # Configure jobid_var
        local saved_jobid_var=$($LCTL get_param -n jobid_var)
        if [ $saved_jobid_var != procname_uid ]; then
@@ -2995,41 +3230,38 @@ test_77f() {
                        "$FSNAME.sys.jobid_var" procname_uid
        fi
 
-       for i in $(seq 1 $OSTCOUNT)
-       do
-               do_facet ost"$i" lctl set_param \
-                       ost.OSS.ost_io.nrs_policies="tbf\ jobid"
-               [ $? -ne 0 ] &&
-                       error "failed to set TBF policy"
-       done
+       do_nodes $oss lctl set_param ost.OSS.ost_io.nrs_policies="tbf\ jobid"
+       [ $? -ne 0 ] && error "failed to set TBF policy"
 
-       # Only operate rules on ost0 since OSTs might run on the same OSS
+       local idis
+       local rateis
+       if [ $(lustre_version_code ost1) -ge $(version_code 2.8.54) ]; then
+               idis="jobid="
+               rateis="rate="
+       fi
+
+       # Only operate rules on ost1 since OSTs might run on the same OSS
        # Add some rules
-       tbf_rule_operate ost0 "start\ runas\ {iozone.$RUNAS_ID\ dd.$RUNAS_ID\ tiotest.$RUNAS_ID}\ 1000"
-       tbf_rule_operate ost0 "start\ iozone_runas\ {iozone.$RUNAS_ID}\ 100"
-       tbf_rule_operate ost0 "start\ dd_runas\ {dd.$RUNAS_ID}\ 50"
+       tbf_rule_operate ost1 "start\ runas\ ${idis}{iozone.$RUNAS_ID\ dd.$RUNAS_ID\ tiotest.$RUNAS_ID}\ ${rateis}1000"
+       tbf_rule_operate ost1 "start\ iozone_runas\ ${idis}{iozone.$RUNAS_ID}\ ${rateis}100"
+       tbf_rule_operate ost1 "start\ dd_runas\ ${idis}{dd.$RUNAS_ID}\ ${rateis}50"
        nrs_write_read "$RUNAS"
 
        # Change the rules
-       tbf_rule_operate ost0 "change\ runas\ 1001"
-       tbf_rule_operate ost0 "change\ iozone_runas\ 101"
-       tbf_rule_operate ost0 "change\ dd_runas\ 51"
+       tbf_rule_operate ost1 "change\ runas\ ${rateis}1001"
+       tbf_rule_operate ost1 "change\ iozone_runas\ ${rateis}101"
+       tbf_rule_operate ost1 "change\ dd_runas\ ${rateis}51"
        nrs_write_read "$RUNAS"
 
        # Stop the rules
-       tbf_rule_operate ost0 "stop\ runas"
-       tbf_rule_operate ost0 "stop\ iozone_runas"
-       tbf_rule_operate ost0 "stop\ dd_runas"
+       tbf_rule_operate ost1 "stop\ runas"
+       tbf_rule_operate ost1 "stop\ iozone_runas"
+       tbf_rule_operate ost1 "stop\ dd_runas"
        nrs_write_read "$RUNAS"
 
        # Cleanup the TBF policy
-       for i in $(seq 1 $OSTCOUNT)
-       do
-               do_facet ost"$i" lctl set_param \
-                       ost.OSS.ost_io.nrs_policies="fifo"
-               [ $? -ne 0 ] &&
-                       error "failed to set policy back to fifo"
-       done
+       do_nodes $oss lctl set_param ost.OSS.ost_io.nrs_policies="fifo"
+       [ $? -ne 0 ] && error "failed to set policy back to fifo"
        nrs_write_read "$RUNAS"
 
        local current_jobid_var=$($LCTL get_param -n jobid_var)
@@ -3043,13 +3275,94 @@ test_77f() {
 run_test 77f "check TBF JobID nrs policy"
 
 test_77g() {
-       for i in $(seq 1 $OSTCOUNT)
-       do
-               do_facet ost"$i" lctl set_param \
-                       ost.OSS.ost_io.nrs_policies="tbf\ nid"
-               [ $? -ne 0 ] &&
-                       error "failed to set TBF policy"
+       local server_version=$(lustre_version_code ost1)
+       [[ $server_version -ge $(version_code 2.7.58) ]] ||
+               { skip "Need server version newer than 2.7.57"; return 0; }
+
+       oss=$(comma_list $(osts_nodes))
+
+       do_nodes $oss lctl set_param ost.OSS.ost_io.nrs_policies="tbf\ nid"
+       [ $? -ne 0 ] && error "failed to set TBF policy"
+
+       do_nodes $oss lctl set_param ost.OSS.ost_io.nrs_policies="tbf\ jobid"
+       [ $? -ne 0 ] && error "failed to set TBF policy"
+
+       local idis
+       local rateis
+       if [ $(lustre_version_code ost1) -ge $(version_code 2.8.54) ]; then
+               idis="jobid="
+               rateis="rate="
+       fi
+
+       # Add a rule that only valid for Jobid TBF. If direct change between
+       # TBF types is not supported, this operation will fail.
+       tbf_rule_operate ost1 "start\ dd_runas\ ${idis}{dd.$RUNAS_ID}\ ${rateis}50"
+
+       # Cleanup the TBF policy
+       do_nodes $oss lctl set_param ost.OSS.ost_io.nrs_policies="fifo"
+       [ $? -ne 0 ] && error "failed to set policy back to fifo"
+       return 0
+}
+run_test 77g "Change TBF type directly"
+
+test_77h() {
+       [ $(lustre_version_code ost1) -ge $(version_code 2.8.55) ] ||
+               { skip "Need OST version at least 2.8.55"; return 0; }
+
+       local old_policy=$(do_facet ost1 \
+               lctl get_param ost.OSS.ost_io.nrs_policies)
+       local new_policy
+
+       do_facet ost1 lctl set_param \
+               ost.OSS.ost_io.nrs_policies="abc"
+       [ $? -eq 0 ] && error "should return error"
+
+       do_facet ost1 lctl set_param \
+               ost.OSS.ost_io.nrs_policies="tbf\ abc"
+       [ $? -eq 0 ] && error "should return error"
+
+       do_facet ost1 lctl set_param \
+               ost.OSS.ost_io.nrs_policies="tbf\ reg\ abc"
+       [ $? -eq 0 ] && error "should return error"
+
+       do_facet ost1 lctl set_param \
+               ost.OSS.ost_io.nrs_policies="tbf\ abc\ efg"
+       [ $? -eq 0 ] && error "should return error"
+
+       new_policy=$(do_facet ost1 lctl get_param ost.OSS.ost_io.nrs_policies)
+       [ $? -eq 0 ] || error "shouldn't LBUG"
+
+       [ "$old_policy" = "$new_policy" ] || error "NRS policy should be same"
+
+       return 0
+}
+run_test 77h "Wrong policy name should report error, not LBUG"
+
+tbf_rule_check()
+{
+       local facet=$1
+       local expected=$2
+       local error_message=$3
+       local rule_number=0
+       for rule in $expected; do
+               rule_number=$((rule_number + 1))
        done
+       local stop_line=$(($rule_number + 3))
+       local awk_command="awk 'NR >= 4 && NR <= $stop_line {print \$1}'"
+
+       local output=$(do_facet $facet lctl get_param \
+               ost.OSS.ost_io.nrs_tbf_rule |
+               eval $awk_command |
+               tr "\n" " " |
+               sed 's/[ ]*$//')
+       if [ "$output" != "$expected" ]; then
+               error "$error_message, expected '$expected', got '$output'"
+       fi
+}
+
+test_77i() {
+    [ $(lustre_version_code ost1) -ge $(version_code 2.8.55) ] ||
+               { skip "Need OST version at least 2.8.55"; return 0; }
 
        for i in $(seq 1 $OSTCOUNT)
        do
@@ -3059,23 +3372,234 @@ test_77g() {
                        error "failed to set TBF policy"
        done
 
-       # Add a rule that only valid for Jobid TBF. If direct change between
-       # TBF types is not supported, this operation will fail.
-       tbf_rule_operate ost0 "start\ dd_runas\ {dd.$RUNAS_ID}\ 50"
+       tbf_rule_check ost1 "default" "error before inserting any rule"
+
+       tbf_rule_operate ost1 "start\ before\ jobid={jobid}\ rate=1000"
+       tbf_rule_check ost1 "before default" \
+               "error when inserting rule 'before'"
+
+       tbf_rule_operate ost1 "start\ after\ jobid={jobid}\ rate=1000\ rank=default"
+       tbf_rule_check ost1 "before after default" \
+               "error when inserting rule 'after'"
+
+       tbf_rule_operate ost1 "start\ target\ jobid={jobid}\ rate=1000\ rank=after"
+       tbf_rule_check ost1 "before target after default" \
+               "error when inserting rule 'target'"
+
+       echo "Move before itself"
+       tbf_rule_operate ost1 "change\ target\ rank=target"
+       tbf_rule_check ost1 "before target after default" \
+               "error when moving before itself"
+
+       echo "Move to higher rank"
+       tbf_rule_operate ost1 "change\ target\ rank=before"
+       tbf_rule_check ost1 "target before after default" \
+               "error when moving to higher rank"
+
+       echo "Move to lower rank"
+       tbf_rule_operate ost1 "change\ target\ rank=after"
+       tbf_rule_check ost1 "before target after default" \
+               "error when moving to lower rank"
+
+       echo "Move before default"
+       tbf_rule_operate ost1 "change\ target\ rank=default"
+       tbf_rule_check ost1 "before after target default" \
+               error "error when moving before default"
 
        # Cleanup the TBF policy
-       for i in $(seq 1 $OSTCOUNT)
-       do
-               do_facet ost"$i" lctl set_param \
+       do_nodes $(comma_list $(osts_nodes)) \
+               $LCTL set_param ost.OSS.ost_io.nrs_policies=fifo
+       return 0
+}
+run_test 77i "Change rank of TBF rule"
+
+test_77j() {
+       local idis
+       local rateis
+       if [ $(lustre_version_code ost1) -ge $(version_code 2.8.60) ]; then
+               idis="opcode="
+               rateis="rate="
+       fi
+
+       do_nodes $(comma_list $(osts_nodes)) \
+               lctl set_param jobid_var=procname_uid \
+                       ost.OSS.ost_io.nrs_policies="tbf\ opcode" \
+                       ost.OSS.ost_io.nrs_tbf_rule="start\ ost_r\ ${idis}{ost_read}\ ${rateis}5" \
+                       ost.OSS.ost_io.nrs_tbf_rule="start\ ost_w\ ${idis}{ost_write}\ ${rateis}20"
+       [ $? -ne 0 ] && error "failed to set TBF OPCode policy"
+
+       nrs_write_read
+       tbf_verify 20 5
+
+       do_nodes $(comma_list $(osts_nodes)) \
+               lctl set_param ost.OSS.ost_io.nrs_tbf_rule="stop\ ost_r" \
+                       ost.OSS.ost_io.nrs_tbf_rule="stop\ ost_w" \
                        ost.OSS.ost_io.nrs_policies="fifo"
-               [ $? -ne 0 ] &&
-                       error "failed to set policy back to fifo"
-       done
+
+       # sleep 3 seconds to wait the tbf policy stop completely,
+       # or the next test case is possible get -EAGAIN when
+       # setting the tbf policy
+       sleep 3
+}
+run_test 77j "check TBF-OPCode NRS policy"
+
+test_77k() {
+       [[ $(lustre_version_code ost1) -ge $(version_code 2.9.53) ]] ||
+               { skip "Need OST version at least 2.9.53"; return 0; }
+
+       do_nodes $(comma_list $(osts_nodes)) \
+               lctl set_param ost.OSS.ost_io.nrs_policies="tbf" \
+                       ost.OSS.ost_io.nrs_tbf_rule="start\ ext_w\ jobid={dd.$RUNAS_ID}\&opcode={ost_write}\ rate=20" \
+                       ost.OSS.ost_io.nrs_tbf_rule="start\ ext_r\ jobid={dd.$RUNAS_ID}\&opcode={ost_read}\ rate=10"
+
+       nrs_write_read "$RUNAS"
+       tbf_verify 20 10 "$RUNAS"
+
+       local address=$(comma_list "$(host_nids_address $CLIENTS $NETTYPE)")
+       local client_nids=$(nids_list $address "\\")
+       do_nodes $(comma_list $(osts_nodes)) \
+               lctl set_param ost.OSS.ost_io.nrs_tbf_rule="stop\ ext_w" \
+                       ost.OSS.ost_io.nrs_tbf_rule="stop\ ext_r" \
+                       ost.OSS.ost_io.nrs_tbf_rule="start\ ext_w\ nid={0@lo\ $client_nids}\&opcode={ost_write}\ rate=20" \
+                       ost.OSS.ost_io.nrs_tbf_rule="start\ ext_r\ nid={0@lo\ $client_nids}\&opcode={ost_read}\ rate=10"
+
+       nrs_write_read
+       tbf_verify 20 10
+
+       do_nodes $(comma_list $(osts_nodes)) \
+               lctl set_param ost.OSS.ost_io.nrs_tbf_rule="stop\ ext_w" \
+                       ost.OSS.ost_io.nrs_tbf_rule="stop\ ext_r" \
+                       ost.OSS.ost_io.nrs_tbf_rule="start\ ext\ nid={0@lo\ $client_nids}\&jobid={dd.$RUNAS_ID}\ rate=20"
+
+       nrs_write_read "$RUNAS"
+       tbf_verify 20 20 "$RUNAS"
+
+       do_nodes $(comma_list $(osts_nodes)) \
+               lctl set_param ost.OSS.ost_io.nrs_tbf_rule="stop\ ext" \
+                       ost.OSS.ost_io.nrs_tbf_rule="start\ ext_a\ jobid={dd.$RUNAS_ID},opcode={ost_write}\ rate=20" \
+                       ost.OSS.ost_io.nrs_tbf_rule="start\ ext_b\ jobid={dd.$RUNAS_ID},opcode={ost_read}\ rate=10"
+
+       nrs_write_read "$RUNAS"
+       # with parameter "RUNAS", it will match the latest rule
+       # "ext_b" first, so the limited write rate is 10.
+       tbf_verify 10 10 "$RUNAS"
+       tbf_verify 20 10
+
+       do_nodes $(comma_list $(osts_nodes)) \
+               lctl set_param ost.OSS.ost_io.nrs_tbf_rule="stop\ ext_a" \
+                       ost.OSS.ost_io.nrs_tbf_rule="stop\ ext_b" \
+                       ost.OSS.ost_io.nrs_policies="fifo"
+
+       sleep 3
+}
+run_test 77k "check the extended TBF policy with NID/JobID/OPCode expression"
+
+test_77l() {
+       if [ $(lustre_version_code ost1) -lt $(version_code 2.9.54) ]; then
+               skip "Need OST version at least 2.9.54"
+               return 0
+       fi
+
+       local dir=$DIR/$tdir
+
+       mkdir $dir || error "mkdir $dir failed"
+       $LFS setstripe -c $OSTCOUNT $dir || error "setstripe to $dir failed"
+       chmod 777 $dir
+
+       local nodes=$(comma_list $(osts_nodes))
+       do_nodes $nodes lctl set_param ost.OSS.ost_io.nrs_policies=delay \
+                                      ost.OSS.ost_io.nrs_delay_min=4 \
+                                      ost.OSS.ost_io.nrs_delay_max=4 \
+                                      ost.OSS.ost_io.nrs_delay_pct=100
+       [ $? -ne 0 ] && error "Failed to set delay policy"
+
+       local start=$SECONDS
+       do_nodes "${SINGLECLIENT:-$HOSTNAME}" "$RUNAS" \
+                dd if=/dev/zero of="$dir/nrs_delay_$HOSTNAME" bs=1M count=1 \
+                  oflag=direct conv=fdatasync ||
+               { do_nodes $nodes lctl set_param ost.OSS.ost_io.nrs_policies="fifo";
+                 error "dd on client failed (1)"; }
+       local elapsed=$((SECONDS - start))
+
+       # NRS delay doesn't do sub-second timing, so a request enqueued at
+       # 0.9 seconds can be dequeued at 4.0
+       [ $elapsed -lt 3 ] &&
+               { do_nodes $nodes lctl set_param ost.OSS.ost_io.nrs_policies="fifo";
+                 error "Single 1M write should take at least 3 seconds"; }
+
+       start=$SECONDS
+       do_nodes "${SINGLECLIENT:-$HOSTNAME}" "$RUNAS" \
+                dd if=/dev/zero of="$dir/nrs_delay_$HOSTNAME" bs=1M count=10 \
+                  oflag=direct conv=fdatasync ||
+               { do_nodes $nodes lctl set_param ost.OSS.ost_io.nrs_policies="fifo";
+                 error "dd on client failed (2)"; }
+       elapsed=$((SECONDS - start))
+
+       [ $elapsed -lt 30 ] &&
+               { do_nodes $nodes lctl set_param ost.OSS.ost_io.nrs_policies="fifo";
+                 error "Ten 1M writes should take at least 30 seconds"; }
+
+       do_nodes $nodes lctl set_param ost.OSS.ost_io.nrs_policies="fifo"
+       [ $? -ne 0 ] && error "failed to set policy back to fifo"
+
        return 0
 }
-run_test 77g "Change TBF type directly"
+run_test 77l "check NRS Delay slows write RPC processing"
+
+test_78() { #LU-6673
+       local server_version=$(lustre_version_code ost1)
+       [[ $server_version -ge $(version_code 2.7.58) ]] ||
+               { skip "Need server version newer than 2.7.57"; return 0; }
+
+       local rc
+
+       oss=$(comma_list $(osts_nodes))
+       do_nodes $oss lctl set_param ost.OSS.ost_io.nrs_policies="orr" &
+       do_nodes $oss lctl set_param ost.OSS.*.nrs_orr_quantum=1
+       rc=$?
+       # Valid return codes are:
+       # 0: Tuning succeeded
+       # ENODEV: Policy is still stopped
+       # EAGAIN: Policy is being initialized
+       [ $rc -eq 0 -o $rc -eq 19 -o $rc -eq 11 ] ||
+               error "Expected set_param to return 0|ENODEV|EAGAIN"
+
+       # Cleanup the ORR policy
+       do_nodes $oss lctl set_param ost.OSS.ost_io.nrs_policies="fifo"
+       [ $? -ne 0 ] && error "failed to set policy back to fifo"
+       return 0
+}
+run_test 78 "Enable policy and specify tunings right away"
+
+test_79() {
+       remote_mds_nodsh && skip "remote MDS with nodsh" && return
+       test_mkdir -p $DIR/$tdir
 
-test_80() {
+       # Prevent interference from layout intent RPCs due to
+       # asynchronous writeback. These will be tested in 130c below.
+       do_nodes ${CLIENTS:-$HOSTNAME} sync
+
+       setfattr -n trusted.name1 -v value1 $DIR/$tdir ||
+               error "setfattr -n trusted.name1=value1 $DIR/$tdir failed"
+
+#define OBD_FAIL_MDS_INTENT_DELAY              0x160
+       local mdtidx=$($LFS getstripe -M $DIR/$tdir)
+       local facet=mds$((mdtidx + 1))
+       stat $DIR/$tdir
+       set_nodes_failloc $(facet_active_host $facet) 0x80000160
+       getfattr -n trusted.name1 $DIR/$tdir 2> /dev/null  &
+       local pid=$!
+       sleep 2
+
+#define OBD_FAIL_MDS_GETXATTR_PACK       0x131
+       set_nodes_failloc $(facet_active_host $facet) 0x80000131
+
+       wait $pid
+       return 0
+}
+run_test 79 "xattr: intent error"
+
+test_80a() {
        [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs" && return
        local MDTIDX=1
        local mdt_index
@@ -3115,7 +3639,130 @@ test_80() {
 
        rm -rf $DIR1/$tdir || error "rm dir failed after migration"
 }
-run_test 80 "migrate directory when some children is being opened"
+run_test 80a "migrate directory when some children is being opened"
+
+cleanup_80b() {
+       trap 0
+       kill -9 $migrate_pid
+}
+
+test_80b() {
+       [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs" && return
+       local migrate_dir1=$DIR1/$tdir/migrate_dir
+       local migrate_dir2=$DIR2/$tdir/migrate_dir
+       local migrate_run=$LUSTRE/tests/migrate.sh
+       local start_time
+       local end_time
+       local show_time=1
+       local mdt_idx
+       local rc=0
+       local rc1=0
+
+       trap cleanup_80b EXIT
+       #prepare migrate directory
+       mkdir -p $migrate_dir1
+       for F in {1,2,3,4,5}; do
+               echo "$F$F$F$F$F" > $migrate_dir1/file$F
+               echo "$F$F$F$F$F" > $DIR/$tdir/file$F
+       done
+
+       #migrate the directories among MDTs
+       (
+               while true; do
+                       mdt_idx=$((RANDOM % MDSCOUNT))
+                       $LFS migrate -m $mdt_idx $migrate_dir1 2&>/dev/null ||
+                               rc=$?
+                       [ $rc -ne 0 -o $rc -ne 16 ] || break
+               done
+       ) &
+       migrate_pid=$!
+
+       echo "start migration thread $migrate_pid"
+       #Access the files at the same time
+       start_time=$(date +%s)
+       echo "accessing the migrating directory for 5 minutes..."
+       while true; do
+               ls $migrate_dir2 > /dev/null || {
+                       echo "read dir fails"
+                       break
+               }
+               diff -u $DIR2/$tdir/file1 $migrate_dir2/file1 || {
+                       echo "access file1 fails"
+                       break
+               }
+
+               cat $migrate_dir2/file2 > $migrate_dir2/file3 || {
+                       echo "access file2/3 fails"
+                       break
+               }
+
+               echo "aaaaa" > $migrate_dir2/file4 > /dev/null || {
+                       echo "access file4 fails"
+                       break
+               }
+
+               stat $migrate_dir2/file5 > /dev/null || {
+                       echo "stat file5 fails"
+                       break
+               }
+
+               touch $migrate_dir2/source_file > /dev/null || rc1=$?
+               [ $rc1 -ne 0 -o $rc1 -ne 1 ] || {
+                       echo "touch file failed with $rc1"
+                       break;
+               }
+
+               if [ -e $migrate_dir2/source_file ]; then
+                       ln $migrate_dir2/source_file $migrate_dir2/link_file \
+                                       2&>/dev/null || rc1=$?
+                       if [ -e $migrate_dir2/link_file ]; then
+                               rm -rf $migrate_dir2/link_file
+                       fi
+
+                       mrename $migrate_dir2/source_file \
+                               $migrate_dir2/target_file 2&>/dev/null || rc1=$?
+                       [ $rc1 -ne 0 -o $rc1 -ne 1 ] || {
+                               echo "rename failed with $rc1"
+                               break
+                       }
+
+                       if [ -e $migrate_dir2/target_file ]; then
+                               rm -rf $migrate_dir2/target_file 2&>/dev/null ||
+                                                               rc1=$?
+                       else
+                               rm -rf $migrate_dir2/source_file 2&>/dev/null ||
+                                                               rc1=$?
+                       fi
+                       [ $rc1 -ne 0 -o $rc1 -ne 1 ] || {
+                               echo "unlink failed with $rc1"
+                               break
+                       }
+               fi
+
+               end_time=$(date +%s)
+               duration=$((end_time - start_time))
+               if [ $((duration % 10)) -eq 0 ]; then
+                       if [ $show_time -eq 1 ]; then
+                               echo "...$duration seconds"
+                               show_time=0
+                       fi
+               else
+                       show_time=1
+               fi
+
+               kill -0 $migrate_pid || {
+                       echo "migration stopped 1"
+                       break
+               }
+
+               [ $duration -ge 300 ] && break
+       done
+
+       #check migration are still there
+       kill -0 $migrate_pid || error "migration stopped 2"
+       cleanup_80b
+}
+run_test 80b "Accessing directory during migration"
 
 test_81() {
        [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs" && return
@@ -3131,7 +3778,7 @@ test_81() {
        touch d0/0      || error "create 0 failed"
        mv d0/0 d1/0    || error "rename d0/0 d1/0 failed"
        stat d0/0       && error "stat mv filed succeed"
-       mv $DIR2/$tdir/d1/0 $DIR2/$tdir/d0/0 || "rename d1/0 d0/0 failed"
+       mv $DIR2/$tdir/d1/0 $DIR2/$tdir/d0/0 || error "rename d1/0 d0/0 failed"
        stat d0/0       || error "stat failed"
 
        local t=$(ls -ai $DIR1/$tdir/d0 | sort -u | wc -l)
@@ -3169,9 +3816,180 @@ test_82() {
 }
 run_test 82 "fsetxattr and fgetxattr on orphan files"
 
+test_83() {
+       [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs" && return
+       local pid1
+       local pid2
+
+       (
+               cd $DIR1
+               while true; do
+                       $LFS mkdir -i1 -c2 $tdir
+                       rmdir $tdir
+               done
+       ) &
+       pid1=$!
+       echo "start pid $pid1 to create/unlink striped directory"
+
+       # Access the directory at the same time
+       (
+               cd $DIR2
+               while true; do
+                       stat $tdir > /dev/null 2>&1
+               done
+       ) &
+       pid2=$!
+       echo "start pid $pid2 to stat striped directory"
+
+       sleep 120
+       kill $pid1 $pid2
+       wait $pid1 $pid2
+
+       return 0
+}
+run_test 83 "access striped directory while it is being created/unlinked"
+
+test_90() {
+       [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs" && return
+       local pid1
+       local pid2
+       local duration=180
+
+       [ "$SLOW" = "yes" ] && duration=600
+       # Open/Create under striped directory
+       (
+               cd $DIR1
+               while true; do
+                       $LFS mkdir -c$MDSCOUNT $tdir > /dev/null 2>&1
+                       touch $tdir/f{0..3} > /dev/null 2>&1
+               done
+       ) &
+       pid1=$!
+       echo "start pid $pid1 to open/create under striped directory"
+
+       # unlink the striped directory at the same time
+       (
+               cd $DIR2
+               while true; do
+                       rm -rf $tdir > /dev/null 2>&1
+               done
+       ) &
+       pid2=$!
+       echo "start pid $pid2 to unlink striped directory"
+
+       sleep $duration
+
+       kill $pid1 $pid2
+       wait $pid1 $pid2
+
+       return 0
+}
+run_test 90 "open/create and unlink striped directory"
+
+test_91() {
+       [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs" && return
+       local pid1
+       local pid2
+       local duration=180
+
+       [ "$SLOW" = "yes" ] && duration=600
+       # chmod striped directory
+       (
+               cd $DIR1
+               while true; do
+                       $LFS mkdir -c$MDSCOUNT $tdir > /dev/null 2>&1
+                       chmod go+w $tdir > /dev/null 2>&1
+               done
+       ) &
+       pid1=$!
+       echo "start pid $pid1 to chmod striped directory"
+
+       # unlink the striped directory at the same time
+       (
+               cd $DIR2
+               while true; do
+                       rm -rf $tdir > /dev/null 2>&1
+               done
+       ) &
+       pid2=$!
+       echo "start pid $pid2 to unlink striped directory"
+
+       sleep $duration
+
+       kill $pid1 $pid2
+       wait $pid1 $pid2
+
+       return 0
+}
+run_test 91 "chmod and unlink striped directory"
+
+test_92() {
+       [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs" && return
+
+       local fd=$(free_fd)
+       local cmd="exec $fd<$DIR1/$tdir"
+       $LFS setdirstripe -c$MDSCOUNT $DIR1/$tdir || error "mkdir $tdir fails"
+       eval $cmd
+       cmd="exec $fd<&-"
+       trap "eval $cmd" EXIT
+       cd $DIR1/$tdir || error "cd $DIR1/$tdir fails"
+       rmdir ../$tdir || error "rmdir ../$tdir fails"
+
+       #define OBD_FAIL_LLITE_NO_CHECK_DEAD  0x1408
+       $LCTL set_param fail_loc=0x1408
+       mkdir $DIR2/$tdir/dir && error "create dir succeeds"
+       $LFS setdirstripe -i1 $DIR2/$tdir/remote_dir &&
+               error "create remote dir succeeds"
+       $LCTL set_param fail_loc=0
+       eval $cmd
+       return 0
+}
+run_test 92 "create remote directory under orphan directory"
+
+test_93() {
+       local rc1=0
+       local rc2=0
+       local old_rr
+
+       mkdir -p $DIR1/$tfile-1/
+       mkdir -p $DIR2/$tfile-2/
+       local old_rr=$(do_facet $SINGLEMDS lctl get_param -n \
+               'lod.lustre-MDT*/qos_threshold_rr' | sed -e 's/%//')
+       do_facet $SINGLEMDS lctl set_param -n \
+               'lod.lustre-MDT*/qos_threshold_rr' 100
+       #define OBD_FAIL_MDS_LOV_CREATE_RACE     0x163
+       do_facet $SINGLEMDS "lctl set_param fail_loc=0x00000163"
+
+       $SETSTRIPE -c -1 $DIR1/$tfile-1/file1 &
+       local PID1=$!
+       sleep 1
+       $SETSTRIPE -c -1 $DIR2/$tfile-2/file2 &
+       local PID2=$!
+       wait $PID2
+       wait $PID1
+       do_facet $SINGLEMDS "lctl set_param fail_loc=0x0"
+       do_facet $SINGLEMDS "lctl set_param -n \
+               'lod.lustre-MDT*/qos_threshold_rr' $old_rr"
+
+       $GETSTRIPE $DIR1/$tfile-1/file1
+       rc1=$($GETSTRIPE -q $DIR1/$tfile-1/file1 |
+               awk '{if (/[0-9]/) print $1 }' | sort | uniq -d | wc -l)
+       $GETSTRIPE $DIR2/$tfile-2/file2
+       rc2=$($GETSTRIPE -q $DIR2/$tfile-2/file2 |
+               awk '{if (/[0-9]/) print $1 }' | sort | uniq -d | wc -l)
+       echo "rc1=$rc1 and rc2=$rc2 "
+       [ $rc1 -eq 0 ] && [ $rc2 -eq 0 ] ||
+               error "object allocate on same ost detected"
+}
+run_test 93 "alloc_rr should not allocate on same ost"
+
 log "cleanup: ======================================================"
 
-[ "$(mount | grep $MOUNT2)" ] && umount $MOUNT2
+# kill and wait in each test only guarentee script finish, but command in script
+# like 'rm' 'chmod' may still be running, wait for all commands to finish
+# otherwise umount below will fail
+[ "$(mount | grep $MOUNT2)" ] && wait_update $HOSTNAME "fuser -m $MOUNT2" "" ||
+       true
 
 complete $SECONDS
 rm -f $SAMPLE_FILE